'==============================================================================
'
'  Address Book for PowerBASIC for Windows PB/WIN
'  Copyright (c) 1999-2002 PowerBASIC, Inc.
'
'  A simple address book example using Dynamic Dialog Tools (DDT)
'
'==============================================================================


'------------------------------------------------------------------------------
' Metastatements
'------------------------------------------------------------------------------
#COMPILE EXE
'#DIM ALL

'------------------------------------------------------------------------------
' Include files
'------------------------------------------------------------------------------
'#INCLUDE "WIN32API.INC"
'-----------------------------------------------------------------
' Equates:  43
'-----------------------------------------------------------------
%WINAPI                                         = 1
%SM_CXSCREEN                                    = 0
%SM_CYSCREEN                                    = 1
%TRUE                                           = 1
%FALSE                                          = 0
%WM_USER                                        = &H400
%Blue                                           = &HFF0000???
%Red                                            = &H0000FF???
%White                                          = &HFFFFFF???
%SW_SHOWNORMAL                                  = 1
%VK_RETURN                                      = &H0D
%VK_ESCAPE                                      = &H1B
%WM_DESTROY                                     = &H2
%WM_COMMAND                                     = &H111
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_VSCROLL                                     = &H00200000
%WS_SYSMENU                                     = &H00080000
%WS_TABSTOP                                     = &H00010000
%WS_EX_TOPMOST                                  = &H00000008
%WS_EX_TOOLWINDOW                               = &H00000080
%WS_EX_CLIENTEDGE                               = &H00000200
%WS_EX_STATICEDGE                               = &H00020000
%CS_DROPSHADOW                                  = &H00020000
%MB_ICONHAND                                    = &H00000010&
%MB_ICONERROR                                   = %MB_ICONHAND
%MF_ENABLED                                     = &H0&
%IDOK                                           = 1
%IDCANCEL                                       = 2
%ES_MULTILINE                                   = &H4&
%ES_AUTOVSCROLL                                 = &H40&
%ES_AUTOHSCROLL                                 = &H80&
%ES_WANTRETURN                                  = &H1000&
%EN_UPDATE                                      = &H400
%BS_DEFPUSHBUTTON                               = &H1&
%BS_DEFAULT                                     = %BS_DEFPUSHBUTTON
%BN_CLICKED                                     = 0
%SS_CENTER                                      = &H00000001
%SS_RIGHT                                       = &H00000002
%SS_SUNKEN                                      = &H00001000
%DS_MODALFRAME                                  = &H0080& '  Can be combined with WS_CAPTION
%DS_CENTER                                      = &H0800&
%CBN_SELCHANGE                                  = 1
%CBS_DROPDOWNLIST                               = &H3&
%CB_GETCURSEL                                   = &H147
%CB_SETCURSEL                                   = &H14E

'-----------------------------------------------------------------
' TYPE and UNION structures:  7
'-----------------------------------------------------------------
TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE POINTAPI
  x AS LONG
  y AS LONG
END TYPE

TYPE tagMSG
  hwnd AS DWORD
  message AS DWORD
  wParam AS LONG
  lParam AS LONG
  time AS DWORD
  pt AS POINTAPI
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    style AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

TYPE BITMAP
  bmType AS LONG
  bmWidth AS LONG
  bmHeight AS LONG
  bmWidthBytes AS LONG
  bmPlanes AS WORD
  bmBitsPixel AS WORD
  bmBits AS BYTE PTR
END TYPE

TYPE DRAWITEMSTRUCT
  CtlType AS DWORD
  CtlID AS DWORD
  itemID AS DWORD
  itemAction AS DWORD
  itemState AS DWORD
  hwndItem AS LONG
  hDC AS DWORD
  rcItem AS RECT
  itemData AS DWORD
END TYPE

TYPE FINDREPLACE
    lStructSize      AS DWORD
    hWndOwner        AS LONG
    hInstance        AS LONG
    Flags            AS DWORD
    lpstrFindWhat    AS ASCIIZ PTR
    lpstrReplaceWith AS ASCIIZ PTR
    wFindWhatLen     AS WORD
    wReplaceWithLen  AS WORD
    lCustData        AS LONG
    lpfnHook         AS DWORD
    lpTemplateName   AS ASCIIZ PTR
END TYPE

'-----------------------------------------------------------------
' Declared Functions:  4
'-----------------------------------------------------------------
DECLARE FUNCTION GetProp LIB "USER32.DLL" ALIAS "GetPropA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION RemoveProp LIB "USER32.DLL" ALIAS "RemovePropA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION SetProp LIB "USER32.DLL" ALIAS "SetPropA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ, BYVAL hData AS DWORD) AS LONG
DECLARE FUNCTION GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD

#INCLUDE "WINLIFT.INC"

'------------------------------------------------------------------------------
' Equates
'------------------------------------------------------------------------------
$AppTitle = "Address Book - skinned by WinLIFT"

' Edit Control IDs
%ID_INDEX       = 100
%ID_COMPANY     = 101
%ID_LASTNAME    = 102
%ID_FIRSTNAME   = 103
%ID_ADDRESS1    = 104
%ID_ADDRESS2    = 105
%ID_ADDRESS3    = 106
%ID_CITYNAME    = 107
%ID_STATENAME   = 108
%ID_ZIPCODE     = 109
%ID_COUNTRY     = 110
%ID_PHONE       = 111
%ID_FAX         = 112
%ID_EMAIL       = 113
%ID_URL         = 114
%ID_COMMENTS    = 115

' Button control IDs
%ID_PRIOR       = 121
%ID_NEXT        = 122
%ID_ADD         = 123
%ID_UPDATE      = 124
%ID_FIND        = 125
%ID_DELETE      = 126

' Menu control IDs
%ID_MENU_CLOSE  = %IDCANCEL
%ID_MENU_CUT    = 201
%ID_MENU_COPY   = 202
%ID_MENU_PASTE  = 203
%ID_MENU_HELP   = 204
%ID_MENU_ABOUT  = 205


'------------------------------------------------------------------------------
' Data structures
'------------------------------------------------------------------------------
TYPE AddressType BYTE
    Company   AS STRING * 64
    LastName  AS STRING * 32
    FirstName AS STRING * 32
    Address1  AS STRING * 64
    Address2  AS STRING * 64
    Address3  AS STRING * 64
    CityName  AS STRING * 24
    StateName AS STRING * 4
    ZipCode   AS STRING * 12
    Country   AS LONG
    Phone     AS STRING * 24
    Fax       AS STRING * 24
    Email     AS STRING * 64
    Url       AS STRING * 64
    Comments  AS STRING * 1024
END TYPE


'------------------------------------------------------------------------------
' Global data variables
'------------------------------------------------------------------------------
GLOBAL gIsRecModified  AS LONG
GLOBAL gIsFileModified AS LONG
GLOBAL gAddressBook()  AS AddressType
GLOBAL gCurrentEntry   AS LONG
GLOBAL gMaxEntries     AS LONG
GLOBAL gszFindText     AS ASCIIZ * 1024


'------------------------------------------------------------------------------
' Callback Declarations
'------------------------------------------------------------------------------
DECLARE CALLBACK FUNCTION AddressCallBack()
DECLARE CALLBACK FUNCTION PriorNextCallBack()
DECLARE CALLBACK FUNCTION AddUpdateCallBack()
DECLARE CALLBACK FUNCTION DeleteCallBack()
DECLARE CALLBACK FUNCTION OkCallBack()
DECLARE CALLBACK FUNCTION FindCallBack()
DECLARE CALLBACK FUNCTION FindDialogCallBack()
DECLARE CALLBACK FUNCTION CancelCallBack()


'------------------------------------------------------------------------------
' Helper Sub/Function Declarations
'------------------------------------------------------------------------------
DECLARE SUB DialogToUdt(BYVAL hDlg AS DWORD, Index AS LONG)
DECLARE SUB UdtToDialog(BYVAL hDlg AS DWORD, Index AS LONG)
DECLARE SUB SetButtonStatus(BYVAL hDlg AS DWORD)
DECLARE SUB AddCountries(BYVAL hDlg AS DWORD)


'------------------------------------------------------------------------------
' Main entry point for the application
'------------------------------------------------------------------------------
FUNCTION PBMAIN () AS LONG

    REGISTER x       AS LONG

    LOCAL    hDlg    AS DWORD
    LOCAL    hMenu   AS DWORD
    LOCAL    Result  AS LONG
    LOCAL    hPopup1 AS DWORD
    LOCAL    hPopup2 AS DWORD
    LOCAL    nFile   AS LONG

    ' Initialize data structure
    DIM gAddressBook(1 TO 1) AS GLOBAL AddressType

    ' Load our data file (if it exists)
    nFile = FREEFILE
    OPEN "ADDRESS.DAT" FOR RANDOM AS #nFile LEN = SIZEOF(gAddressBook(1))

    x = LOF(nFile) \ SIZEOF(gAddressBook(1))
    IF ISTRUE x THEN
        ' We have data, so we'll reinitialize the variable that track usage
        gCurrentEntry = 1
        gMaxEntries = x
        REDIM gAddressBook(1 TO gMaxEntries) AS GLOBAL AddressType

        ' Get the data
        FOR x = 1 TO gMaxEntries
            GET #nFile, x, gAddressBook(x)
        NEXT x
    END IF

    CLOSE #nFile

    ' Create our primary GUI
    Style& = %DS_CENTER OR %WS_CAPTION OR %WS_SYSMENU
    'DIALOG NEW 0, $AppTitle, 77, 22, 400, 267, Style&, 0 TO hDlg
    StyleEx& = %WS_EX_STATICEDGE
    DIALOG NEW PIXELS, 0, $AppTitle,(GetSystemMetrics(%SM_CXSCREEN) - 610) / 2, _
                                    (GetSystemMetrics(%SM_CYSCREEN) - 470) / 2, _
                                    610, 470, Style&, StyleEx& TO hDlg

    ' Abort if the dialog could not be created
    IF hDlg = 0 THEN EXIT FUNCTION  ' Error occurred

    DIALOG SET COLOR hDlg, -1&, RGB(255,255,222)

    ' Now we create our controls.  We create the static control immediately before the
    ' real control so that the keyboard accelerators switch focus to the real control
    CONTROL ADD LABEL,    hDlg, 20,        "Record N", 455,   8,  90,  16, %SS_RIGHT
    CONTROL ADD LABEL,    hDlg, %id_Index,     "0 / 0", 549,   7,  38,  16, %SS_SUNKEN OR %SS_CENTER

    CONTROL ADD LABEL,    hDlg, 21,         "Compan&y",   8,  30,  90,  16, %SS_RIGHT
    CONTROL ADD TEXTBOX,  hDlg, %id_Company,     "101", 102,  28, 485,  20'19

    CONTROL ADD LABEL,    hDlg, 22,       "Last Na&me",   8,  54,  90,  16, %SS_RIGHT
    CONTROL ADD TEXTBOX,  hDlg, %id_LastName,    "102", 102,  52, 225,  20'19

    CONTROL ADD LABEL,    hDlg, 23,           "Fi&rst", 330, 54, 28, 16, %SS_RIGHT
    CONTROL ADD TEXTBOX,  hDlg, %id_FirstName,   "103", 362, 52, 225, 20'19

    CONTROL ADD LABEL,    hDlg, 24,         "Addre&ss",   8, 78, 90, 16, %SS_RIGHT
    CONTROL ADD TEXTBOX,  hDlg, %id_Address1,    "104", 102, 76, 485, 20'19
    CONTROL ADD TEXTBOX,  hDlg, %id_Address2,    "105", 102, 100, 485, 20'19
    CONTROL ADD TEXTBOX,  hDlg, %id_Address3,    "106", 102, 124, 485, 20'19

    CONTROL ADD LABEL,    hDlg, 25,            "Ci&ty",   8, 150, 90, 16, %SS_RIGHT
    CONTROL ADD TEXTBOX,  hDlg, %id_CityName,    "107", 102, 148, 174, 20'19

    CONTROL ADD LABEL,    hDlg, 26,  "State/Pro&vince", 280, 150, 80, 16, %SS_RIGHT
    CONTROL ADD TEXTBOX,  hDlg, %id_StateName,   "108", 362, 148, 67, 20'19

    CONTROL ADD LABEL,    hDlg, 27, "&Zip or Postal Code",8, 174, 90, 16, %SS_RIGHT
    CONTROL ADD TEXTBOX,  hDlg, %id_ZipCode,     "109", 102, 172, 60, 20'19

    CONTROL ADD LABEL,    hDlg, 28,         "Co&untry", 192, 174, 44, 16, %SS_RIGHT
    CONTROL ADD COMBOBOX, hDlg, %id_Country,          , 238, 172, 192, 160, %CBS_DROPDOWNLIST OR %WS_VSCROLL OR %WS_TABSTOP

    CONTROL ADD LABEL,    hDlg, 29,           "Ph&one",   8, 205, 90, 16, %SS_RIGHT
    CONTROL ADD TEXTBOX,  hDlg, %id_Phone,       "111", 102, 203, 225, 20'19

    CONTROL ADD LABEL,    hDlg, 30,             "Fa&x", 330, 205, 27, 16, %SS_RIGHT
    CONTROL ADD TEXTBOX,  hDlg, %id_Fax,         "112", 362, 203, 225, 20'19

    CONTROL ADD LABEL,    hDlg, 31,           "Ema&il",   8, 229, 90, 16, %SS_RIGHT
    CONTROL ADD TEXTBOX,  hDlg, %id_Email,       "113", 102, 227, 225, 20'19

    CONTROL ADD LABEL,    hDlg, 32,             "&www", 330, 229, 29, 16, %SS_RIGHT'27
    CONTROL ADD TEXTBOX,  hDlg, %id_Url,         "114", 362, 227, 225, 20'19

    CONTROL ADD LABEL,    hDlg, 33,        "C&omments",   8, 253, 90, 16, %SS_RIGHT
    CONTROL ADD TEXTBOX,  hDlg, %id_Comments,    "115", 102, 251, 485, 105, %ES_AUTOHSCROLL OR %ES_AUTOVSCROLL OR %ES_MULTILINE OR %ES_WANTRETURN OR %WS_TABSTOP OR %WS_VSCROLL, %WS_EX_CLIENTEDGE

    ' Color the LABEL controls (foreground = default, background = transparent)
    FOR x = 20 TO 33
        CONTROL SET COLOR hDlg, x, -1, -2
    NEXT x


    ' Add the command buttons
    CONTROL ADD BUTTON,   hDlg, %id_Prior, "&Prior <<",  15, 398, 63, 24 CALL PriorNextCallBack
    CONTROL ADD BUTTON,   hDlg, %id_Next,   ">> &Next",  90, 398, 63, 24 CALL PriorNextCallBack
    CONTROL ADD BUTTON,   hDlg, %id_Add,        "&Add", 165, 398, 63, 24 CALL AddUpdateCallBack
    CONTROL ADD BUTTON,   hDlg, %id_Update,  "U&pdate", 240, 398, 63, 24 CALL AddUpdateCallBack
    CONTROL ADD BUTTON,   hDlg, %id_Find,      "&Find", 315, 398, 63, 24 CALL FindCallBack
    CONTROL ADD BUTTON,   hDlg, %id_Delete,  "&Delete", 390, 398, 63, 24 CALL DeleteCallBack
    CONTROL ADD BUTTON,   hDlg, %IDCANCEL,    "&Close", 525, 398, 63, 24 CALL CancelCallBack

    ' Add a menu bar to the GUI
    MENU NEW BAR TO hMenu

    ' Create a popup menu
    MENU NEW POPUP TO hPopup1
    MENU ADD STRING, hPopup1, "&Close", %IDCANCEL, %MF_ENABLED
    ' Attach the popup menu to the menu bar
    MENU ADD POPUP,  hMenu,   "&File",  hPopup1,   %MF_ENABLED

    ' Create a popup menu
    MENU NEW POPUP TO hPopup2
    MENU ADD STRING, hPopup2, "&Help",  %id_Menu_Help,  %MF_ENABLED
    MENU ADD STRING, hPopup2, "-",      0,              0
    MENU ADD STRING, hPopup2, "&About", %id_Menu_About, %MF_ENABLED
    MENU ADD POPUP,  hMenu,   "&Help",  hPopup2,        %MF_ENABLED

    ' Attach the popup menu to the menu bar
    MENU ATTACH hMenu, hDlg

    ' Initialize our combobox Country List
    AddCountries hDlg

    ' Update our "scroll" buttons
    SetButtonStatus hDlg

    ' Set the 1st address from the UDT array into the GUI
    UdtToDialog hDlg, gCurrentEntry

    'IF skInitEngine("Aero.sks", "") THEN 
    'IF skInitEngine("Matrix.sks", "") THEN 
    IF skInitEngine("Busi.sks", "") THEN 
       CALL skSkinWindow(hDlg, "Dock|Undock|Minimize|Maximize|Restore|Close")

'CALL skSetLabelFont(GetDlgItem(hDlg, 33), "ARIAL", 16, skARGB(255, 0,128,0), %FontStyleBoldItalic)
'CALL skSetLabelFont(GetDlgItem(hDlg, %id_Add), "ARIAL", 12, skARGB(255, 0,128,0), %FontStyleBoldItalic)

    END IF

    ' Start up our GUI, and run until the user quits
    DIALOG SHOW MODAL hDlg, CALL AddressCallBack TO Result

    ' Save our data file if any changes were made
    IF gIsFileModified THEN
        ARRAY SORT gAddressBook(1) FOR gMaxEntries, FROM 1 TO LEN(gAddressBook(1).Company + gAddressBook(1).LastName)
        nFile = FREEFILE
        OPEN "ADDRESS.DAT" FOR RANDOM AS #nFile LEN = SIZEOF(gAddressBook(1))

        FOR x = 1 TO gMaxEntries
            PUT #nFile, x, gAddressBook(x)
        NEXT x

        ' Now truncate the file at the current position in case there are less
        ' records than when we began
        SETEOF #nFile
        CLOSE #nFile
    END IF

END FUNCTION


'------------------------------------------------------------------------------
' Main dialog callback
'------------------------------------------------------------------------------
CALLBACK FUNCTION AddressCallBack

    LOCAL Dummy AS LONG
    LOCAL hDlg  AS DWORD

    SELECT CASE CBMSG

    CASE %WM_COMMAND
        ' If any control is edited, we need to register this so the ADD and
        ' UPDATE buttons can be enabled.
        IF CBCTLMSG = %EN_UPDATE _       ' *Any* edit control was changed
        OR (CBCTL = %id_Country AND CBCTLMSG = %CBN_SELCHANGE) THEN ' The Country combobox was changed
            ' If this is the first "change" message, we need to update the
            ' controls in the dialog box.
            IF ISFALSE gIsRecModified THEN
                gIsRecModified = %TRUE
                SetButtonStatus CBHNDL
            END IF
        END IF

        ' Now process any other %WM_COMMAND message from controls that don't
        ' have their own callback functions.
        SELECT CASE CBCTL

        CASE %id_Menu_Help
            Dummy = SHELL("WINHELP.EXE", 1)

        CASE %id_Menu_About
            ' About dialog
            'DIALOG NEW CBHNDL, $AppTitle, 0, 0, 170, 60, _
            '            %DS_MODALFRAME OR %WS_CAPTION OR %WS_SYSMENU OR %DS_CENTER TO hDlg
            'DIALOG SET COLOR hDlg, -1&, %BLUE
            'IF hDlg = 0 THEN EXIT FUNCTION  ' Error occurred
            'CONTROL ADD LABEL, hDlg, -1, "A PB/WIN DDT example" & $CRLF & $CRLF & "by PowerBASIC, Inc.", _
            '            15, 10, 130, 34, %SS_CENTER
            'CONTROL SET COLOR hDlg, -1, %WHITE, %BLUE
            'CONTROL ADD BUTTON, hDlg, 1, "&Ok", 60, 42, 40, 14 CALL OkCallBack
            'CALL skSkinWindow(hDlg, "Dock|Undock|Minimize|Maximize|Restore|Close")
            CALL skDialogInfo("", "INFO" + $CR + $CR + $CR + "A PB/WIN DDT example" + $CR & $CR + "by PowerBASIC, Inc.", "")

            BEEP
            DIALOG SHOW MODAL hDlg
        END SELECT

    END SELECT

END FUNCTION


'------------------------------------------------------------------------------
' PRIOR/NEXT Button callback function
'------------------------------------------------------------------------------
CALLBACK FUNCTION PriorNextCallBack

    ' Determine which control is originating the message
    IF CBCTL = %id_Prior THEN       ' "Prior" control
        gCurrentEntry = MAX&(gCurrentEntry - 1, 1)
    ELSE                            ' "Next" control
        gCurrentEntry = MIN&(gCurrentEntry + 1, gMaxEntries)
    END IF

    ' Disregard any existing editing if one of these button clicked
    gIsRecModified = %FALSE

    ' Update the dialog
    UdtToDialog CBHNDL, gCurrentEntry

    ' Update the Prior/Next control button status
    SetButtonStatus CBHNDL

END FUNCTION


'------------------------------------------------------------------------------
' ADD and UPDATE Buttons callback function
'------------------------------------------------------------------------------
CALLBACK FUNCTION AddUpdateCallBack

    ' This callback only runs if gIsRecModified is %TRUE
    LOCAL hDlg      AS DWORD
    LOCAL LastName  AS STRING

    ' Get the Last Name field
    CONTROL GET TEXT CBHNDL, %id_LastName TO LastName

    ' Check if Last Name entered, at this stage will will not check for duplicate entries
    IF LEN(LastName) = 0 THEN
        ' Display error message dialog
        DIALOG NEW CBHNDL, $AppTitle, 0, 0, 150, 50, %DS_MODALFRAME OR %WS_CAPTION OR _
            %WS_SYSMENU OR %DS_CENTER TO hDlg
        DIALOG SET COLOR hDlg, -1&, %RED
        IF hDlg = 0 THEN EXIT FUNCTION  ' Error occurred
        CONTROL ADD LABEL, hDlg, -1, "You must specify a Last Name!", 10, 10, 130, 14, %SS_CENTER
        CONTROL SET COLOR hDlg, -1&, %WHITE, -2%
        CONTROL ADD BUTTON, hDlg, 1, "&Ok", 55, 30, 40, 14 CALL OkCallBack

        CALL skSkinWindow(hDlg, "Dock|Undock|Minimize|Maximize|Restore|Close")

        BEEP
        DIALOG SHOW MODAL hDlg

        ' Move focus to the offending control
        CONTROL SET FOCUS CBHNDL, %id_LastName
        EXIT FUNCTION
    END IF

    ' Now determine if ADD or UPDATE buttons clicked
    IF CBCTL = %id_Add OR gMaxEntries < 1 THEN     ' It's the Add button, or we have no existing entries
        ' Extend the UDT array and insert the new address data
        INCR gMaxEntries
        gCurrentEntry = gMaxEntries
        REDIM PRESERVE gAddressBook(1 TO gMaxEntries) AS GLOBAL AddressType
    ELSE                        ' It's the update button
        ' Simply update the existing record
    END IF

    ' Get the data from the dialog
    DialogToUdt CBHNDL, gCurrentEntry

    ' Reset the modified flag
    gIsRecModified = %FALSE

    ' Flag data as modified
    gIsFileModified = %TRUE

    ' Update the dialog controls
    SetButtonStatus CBHNDL

END FUNCTION


'------------------------------------------------------------------------------
' Find button callback function
'------------------------------------------------------------------------------
CALLBACK FUNCTION FindCallBack

    STATIC hDlg   AS DWORD
    STATIC IsFind AS LONG
    LOCAL  x      AS LONG

    ' Is this dialog already active?
    IF ISTRUE IsFind THEN
        ' Yes, switch focus to the edit control in the Find dialog
        CONTROL SET FOCUS hDlg, %IDOK
        EXIT FUNCTION
    END IF

    ' Create our "Find" dialog as a modeless dialog
    DIALOG NEW CBHNDL, "Find Address", 0, 0, 150, 50, %DS_MODALFRAME OR %WS_CAPTION OR _
        %DS_CENTER, %WS_EX_TOPMOST OR %WS_EX_TOOLWINDOW TO hDlg
    IF hDlg = 0 THEN EXIT FUNCTION  ' Error occurred
    DIALOG SET COLOR   hDlg, -1, RGB(222,222,255)
    SetProp hDlg, "Parent", CBHNDL

    CONTROL ADD LABEL, hDlg, -1, "Find &Text:", 1, 7, 20, 28, %SS_RIGHT
    CONTROL SET COLOR  hDlg, -1, %BLUE, -2&

    CONTROL ADD TEXTBOX, hDlg, %id_Find,  gszFindText,  30, 7, 110, 14
    CONTROL ADD BUTTON,  hDlg, %IDOK,     "&Find Next", 30, 30, 40, 14, %BS_DEFAULT
    CONTROL ADD BUTTON,  hDlg, %IDCANCEL, "&Cancel",    80, 30, 40, 14 CALL CancelCallBack

    ' Flag the dialog as active so clicking on the FIND button in the main window won't
    ' trigger a 2nd instance of the Find dialog box
    IsFind = hDlg

    CALL skSkinWindow(hDlg, "Dock|Undock|Minimize|Maximize|Restore|Close")
    ' Display the dialog
    DIALOG SHOW MODELESS hDlg, CALL FindDialogCallBack

    ' Now loop until the dialog is dismissed
    DO
        ' Allow messages to be dispatched
        DIALOG DOEVENTS
        ' Query the dialog size... if the return value is zero, the dialog was destroyed
        DIALOG GET SIZE hDlg TO x, x
    LOOP WHILE x

    ' Reactivate our parent dialog (in case previous window in the z-order was not our
    ' main dialog)
    DIALOG SHOW STATE CBHNDL, %SW_SHOWNORMAL

    ' Clear active flag
    IsFind = %FALSE

END FUNCTION


'------------------------------------------------------------------------------
' Find Dialog callback function
'------------------------------------------------------------------------------
CALLBACK FUNCTION FindDialogCallback

    LOCAL FindText AS ASCIIZ * 1024
    LOCAL x        AS LONG

    SELECT CASE CBMSG

    CASE %WM_DESTROY
        RemoveProp CBHNDL, "Parent"

    CASE %WM_COMMAND
        ' Retrieve the search text if the edit control contents change
        ' We save this in a global variable so we can recreate the Find dialog
        ' with the same search text if it is relaunched again
        IF CBCTLMSG = %EN_UPDATE THEN       ' The find text was changed, save it
            CONTROL GET TEXT CBHNDL, CBCTL TO gszFindText
            ' Strip the string down to the minimum
            gszFindText = TRIM$(gszFindText)
            EXIT FUNCTION
        END IF

        ' Now initiate a search as long as the search text is available
        IF CBCTL = %IDOK AND CBCTLMSG = %BN_CLICKED AND ISTRUE LEN(gszFindText) THEN
            ' Start search from next record and loop from end to start
            FindText = UCASE$(gszFindText)
            FOR x = gCurrentEntry + 1 TO gMaxEntries
                IF INSTR(UCASE$(gAddressBook(x)), FindText) THEN
                    gIsRecModified = %FALSE
                    gCurrentEntry = x
                    UdtToDialog GetProp(CBHNDL, "Parent"), gCurrentEntry
                    EXIT FUNCTION
                END IF
            NEXT

            ' No match between index and end, so restart from beginning of file
            FOR x = 1 TO gCurrentEntry
                IF INSTR(UCASE$(gAddressBook(x)), FindText) THEN
                    gIsRecModified = %FALSE
                    gCurrentEntry = x

                    UdtToDialog GetProp(CBHNDL, "Parent"), gCurrentEntry
                    EXIT FUNCTION
                END IF
            NEXT

            ' Hmmm... no matches at all!
            ' We are not using a DDT dialog here... we could, but we'll just
            ' do this simply for demonstration purposes
            MSGBOX "Not Found", %MB_ICONERROR, $AppTitle
        END IF

    END SELECT

END FUNCTION


'------------------------------------------------------------------------------
' Delete button callback function
'------------------------------------------------------------------------------
CALLBACK FUNCTION DeleteCallBack

    LOCAL hDlg   AS DWORD
    LOCAL Result AS LONG

    ' Only permit a deletion if the index is valid
    IF gCurrentEntry < 1 OR gCurrentEntry > gMaxEntries THEN EXIT FUNCTION

    ' Create the delete confirmation dialog
    DIALOG NEW CBHNDL, $AppTitle, 0, 0, 150, 50, %DS_MODALFRAME OR %WS_CAPTION OR _
        %WS_SYSMENU OR %DS_CENTER TO hDlg
    CONTROL ADD LABEL, hDlg, -1, "Are you sure you wish to" & $CRLF & _
        "delete this record?", 10, 7, 130, 28, %SS_CENTER
    CONTROL ADD BUTTON, hDlg, %IDOK,     "&Ok",     30, 30, 40, 14 CALL OkCallBack
    CONTROL ADD BUTTON, hDlg, %IDCANCEL, "&Cancel", 80, 30, 40, 14 CALL CancelCallBack

    CALL skSkinWindow(hDlg, "Dock|Undock|Minimize|Maximize|Restore|Close")
    BEEP
    DIALOG SHOW MODAL hDlg TO Result

    ' Abort if the dialog was cancelled
    IF ISFALSE Result THEN EXIT FUNCTION

    ' Now perform the removal of the record and update our index variables
    ARRAY DELETE gAddressBook(gCurrentEntry)
    DECR gMaxEntries
    gCurrentEntry = MIN&(gCurrentEntry, gMaxEntries)
    REDIM PRESERVE gAddressBook(1 TO MAX&(1, gMaxEntries)) AS GLOBAL AddressType

    ' Update our status flags & refresh the window
    gIsRecModified = %FALSE
    gIsFileModified = %TRUE
    SetButtonStatus CBHNDL
    UdtToDialog CBHNDL, gCurrentEntry

END FUNCTION



'------------------------------------------------------------------------------
' "Generic" OK callback function for "messagebox" style DDT dialogs
'------------------------------------------------------------------------------
CALLBACK FUNCTION OkCallBack

    DIALOG END CBHNDL, 1

END FUNCTION


'------------------------------------------------------------------------------
' "Generic" CANCEL callback function for "messagebox" style DDT dialogs
'------------------------------------------------------------------------------
CALLBACK FUNCTION CancelCallBack

    DIALOG END CBHNDL, 0

END FUNCTION


'------------------------------------------------------------------------------
' Fill dialog fields from UDT
'------------------------------------------------------------------------------
SUB UdtToDialog(BYVAL hDlg AS DWORD, Index AS LONG)

    LOCAL Temp      AS AddressType
    LOCAL SaveState AS LONG

    IF Index > UBOUND(gAddressBook(1)) OR Index < LBOUND(gAddressBook(1)) THEN
        RESET Temp
    ELSE
        Temp = gAddressBook(Index)
    END IF

    ' When we change the edit control data, we generate EN_UPDATE messages...
    ' Due to the design of our GUI interface, we would end up with the ADD and UPDATE
    ' buttons becoming enabled just because we loaded a new UDT record into the dialog.
    ' To overcome this, we set the "modified" flag to %TRUE, so the main callback
    ' function ingores the "update" notication messages.

    SaveState = gIsRecModified
    gIsRecModified = %TRUE

    CONTROL SET TEXT hDlg, %id_Company,   RTRIM$(Temp.Company)
    CONTROL SET TEXT hDlg, %id_LastName,  RTRIM$(Temp.LastName)
    CONTROL SET TEXT hDlg, %id_FirstName, RTRIM$(Temp.FirstName)
    CONTROL SET TEXT hDlg, %id_Address1,  RTRIM$(Temp.Address1)
    CONTROL SET TEXT hDlg, %id_Address2,  RTRIM$(Temp.Address2)
    CONTROL SET TEXT hDlg, %id_Address3,  RTRIM$(Temp.Address3)
    CONTROL SET TEXT hDlg, %id_CityName,  RTRIM$(Temp.CityName)
    CONTROL SET TEXT hDlg, %id_StateName, RTRIM$(Temp.StateName)
    CONTROL SET TEXT hDlg, %id_ZipCode,   RTRIM$(Temp.ZipCode)
    CONTROL SEND     hDlg, %id_Country,   %CB_SETCURSEL, Temp.Country, 0
    CONTROL SET TEXT hDlg, %id_Phone,     RTRIM$(Temp.Phone)
    CONTROL SET TEXT hDlg, %id_Fax,       RTRIM$(Temp.Fax)
    CONTROL SET TEXT hDlg, %id_Email,     RTRIM$(Temp.Email)
    CONTROL SET TEXT hDlg, %id_Url,       RTRIM$(Temp.Url)
    CONTROL SET TEXT hDlg, %id_Comments,  RTRIM$(Temp.Comments)

    ' Restore the previous state
    gIsRecModified = SaveState

END SUB


'------------------------------------------------------------------------------
' Fill UDT from dialog fields
'------------------------------------------------------------------------------
SUB DialogToUdt (BYVAL hDlg AS DWORD, Index AS LONG)

    LOCAL Temp AS AddressType

    IF Index > UBOUND(gAddressBook(1)) OR Index < LBOUND(gAddressBook(1)) THEN
        EXIT SUB
    END IF

    Temp = gAddressBook(Index)

    CONTROL GET TEXT hDlg, %id_Company   TO Temp.Company
    CONTROL GET TEXT hDlg, %id_LastName  TO Temp.LastName
    CONTROL GET TEXT hDlg, %id_FirstName TO Temp.FirstName
    CONTROL GET TEXT hDlg, %id_Address1  TO Temp.Address1
    CONTROL GET TEXT hDlg, %id_Address2  TO Temp.Address2
    CONTROL GET TEXT hDlg, %id_Address3  TO Temp.Address3
    CONTROL GET TEXT hDlg, %id_CityName  TO Temp.CityName
    CONTROL GET TEXT hDlg, %id_StateName TO Temp.StateName
    CONTROL GET TEXT hDlg, %id_ZipCode   TO Temp.ZipCode
    CONTROL SEND     hDlg, %id_Country,  %CB_GETCURSEL, 0, 0 TO Temp.Country
    CONTROL GET TEXT hDlg, %id_Phone     TO Temp.Phone
    CONTROL GET TEXT hDlg, %id_Fax       TO Temp.Fax
    CONTROL GET TEXT hDlg, %id_Email     TO Temp.Email
    CONTROL GET TEXT hDlg, %id_Url       TO Temp.Url
    CONTROL GET TEXT hDlg, %id_Comments  TO Temp.Comments

    gAddressBook(Index) = Temp

END SUB


'------------------------------------------------------------------------------
' Update the dialog controls
'------------------------------------------------------------------------------
SUB SetButtonStatus(BYVAL hDlg AS DWORD)

    ' If any current text is modified, make the ADD & Update buttons active
    IF ISTRUE gIsRecModified THEN
        CONTROL ENABLE  hDlg, %id_Add
        CONTROL ENABLE  hDlg, %id_Update
    ELSE
        CONTROL DISABLE hDlg, %id_Add
        CONTROL DISABLE hDlg, %id_Update
    END IF

    ' Update the Index control text
    CONTROL SET TEXT hDlg, %id_Index, FORMAT$(gCurrentEntry) & " / " & FORMAT$(gMaxEntries)

    ' Do we have any records? is not, disable the Prior/Next buttons, etc
    IF ISFALSE gMaxEntries THEN
        CONTROL DISABLE hDlg, %id_Prior
        CONTROL DISABLE hDlg, %id_Next
        CONTROL DISABLE hDlg, %id_Find
        CONTROL DISABLE hDlg, %id_Delete
        EXIT SUB
    END IF

    ' If there are records, allow the Find/Delete buttons
    CONTROL ENABLE hDlg, %id_Find
    CONTROL ENABLE hDlg, %id_Delete

    ' We have records, so set the Prior button status according to the current index position
    IF gCurrentEntry <= 1 THEN
        CONTROL DISABLE hDlg, %id_Prior
    ELSE
        CONTROL ENABLE  hDlg, %id_Prior
    END IF

    ' Update the Next control button
    IF gCurrentEntry >= gMaxEntries THEN
        CONTROL DISABLE hDlg, %id_Next
    ELSE
        CONTROL ENABLE  hDlg, %id_Next
    END IF

END SUB


'------------------------------------------------------------------------------
' Prefill the ComboBox control with the names of countries
'------------------------------------------------------------------------------
SUB AddCountries(BYVAL hDlg AS DWORD)

    LOCAL x AS LONG

    ' Clear the combo box list
    COMBOBOX RESET hDlg, %id_Country
    FOR x = 1 TO DATACOUNT
        COMBOBOX ADD hDlg, %id_Country, READ$(x)
    NEXT

    DATA "United States", "Afghanistan", "Albania", "Algeria", "Andorra", "Angola", "Anguilla"
    DATA "Antarctica", "Argentina", "Armenia", "Aruba", "Australia", "Austria"
    DATA "Azerbaijan", "Bahamas", "Bahrain", "Bangladesh", "Barbados", "Belarus"
    DATA "Belgium", "Belize", "Benin", "Bermuda", "Bhutan", "Bolivia", "Botswana"
    DATA "Bouvet Island", "BosniaHerzogovina", "Brazil", "Brunei", "Bulgaria"
    DATA "Burkina Faso", "Cambodia", "Cameroon", "Canada", "Cape Verde"
    DATA "Cayman Islands", "Central African Rep", "Chad", "Chile", "China"
    DATA "Christmas Island", "Colombia", "Comoros", "Congo", "Cook Islands"
    DATA "Costa Rica", "Croatia", "Cuba", "Cyprus", "Czech Republic", "Denmark"
    DATA "Djibouti", "Dominica", "Dominican Republic", "East Timor", "Ecuador"
    DATA "Egypt", "El Salvador", "Equatorial Guinea", "Eritrea", "Estonia"
    DATA "Ethiopia", "Falkland Islands", "Faroe Islands", "Fiji", "Finland"
    DATA "France", "France Metropolitan", "French Guiana", "French Polynesia"
    DATA "French S. Territories", "Gabon", "Gambia", "Georgia", "Germany", "Ghana"
    DATA "Gibraltar", "Greece", "Greenland", "Grenada", "Guadeloupe", "Guam"
    DATA "Guatemala", "Guinea", "Guinea-Bissau", "Guyana", "Haiti", "Honduras"
    DATA "Hong Kong", "Hungary", "Iceland", "IN India", "Indonesia", "Iran", "Iraq"
    DATA "Ireland", "Israel", "Italy", "Ivory Coast", "Jamaica", "Japan", "Jordan"
    DATA "Kazakhstan", "Kenya", "Kiribati", "Korea (North)", "Korea (South)"
    DATA "Kuwait", "Kyrgyzstan", "Laos", "Latvia", "Lebanon", "Lesotho", "Liberia"
    DATA "Libya", "Liechtenstein", "Lithuania", "Luxembourg", "Macau", "Macedonia"
    DATA "Madagascar", "Malawi", "Malaysia", "Maldives", "Mali", "Malta"
    DATA "Marshall Islands", "Martinique", "Mauritania", "Mauritius", "Mayotte"
    DATA "Mexico", "Micronesia", "Miquelon", "Moldova", "Monaco", "Mongolia", "Montserrat"
    DATA "Morocco", "Mozambique", "Myanmar", "Namibia", "Nauru", "Nepal"
    DATA "Netherlands", "Nevis", "New Caledonia", "New Guinea", "New Zealand"
    DATA "Nicaragua", "Niger", "Nigeria", "Niue", "Norfolk Island", "Norway"
    DATA "Oman", "Pakistan", "Palau", "Panama", "Paraguay", "Peru", "Philippines"
    DATA "Pitcairn", "Poland", "Portugal", "Principe", "Puerto Rico", "Qatar"
    DATA "Reunion", "Romania", "Russian Federation", "Rwanda", "Saint Kitts"
    DATA "Saint Lucia", "Samoa", "San Marino", "Sao Tome", "Saudi Arabia", "Senegal"
    DATA "Seychelles", "Sierra Leone", "Singapore", "Slovak Republic", "Slovenia"
    DATA "Solomon Islands", "Somalia", "South Africa", "Spain", "Sri Lanka"
    DATA "St. Helena", "St. Pierre", "Sudan", "Suriname", "Swaziland", "Sweden"
    DATA "Switzerland", "Syria", "Taiwan", "Tajikistan", "Tanzania", "Thailand"
    DATA "Tobago", "Togo", "Tokelau", "Tonga", "Trinidad", "Tunisia", "Turkey"
    DATA "Turkmenistan", "Tuvalu", "Uganda", "Ukraine", "United Arab Emirates"
    DATA "United Kingdom", "United States", "Uruguay", "Uzbekistan", "Vanuatu"
    DATA "Vatican City State", "Venezuela", "Viet Nam", "Virgin Islands (BR)"
    DATA "Virgin Islands (US)", "Western Sahara", "Yemen", "Yugoslavia", "Zaire"
    DATA "Zambia", "Zimbabwe", "Other"

END SUB
'------------------------------------------------------------------------------
