'
' CharMap2.bas for Windows 95/98, Public Domain by Borje Hagsten, April 2001.
' Almost identical to MS CharMap. A silly utility that has proved to
' be extremely useful in lots of programming tasks. I have embedded
' it in my own editor and often use it to see/copy characters from
' the extended ASCII, as an example.
'
' Free to use and modify - but as always, at own responsability.. :)
'
' NOTE: Compiled exe, code, icon and bitmap for ownerdrawn combo
' can be downloaded from http://www.tolkenxp.com/pb/pbchmap.zip
'
' LOG:
' Jan 19, 2002: Corrections made for latest win32api.inc and PB/WIN 7
'
' Teaches what? Well, things like a way create a grid and move a
' control around with the arrow keys, for one thing. Useful in game
' programming, for example. Also shows how to make a "True type"
' style font combo, like the one MS uses. Resource file includes icon,
' TrueType bitmap and version info - change in whatever way you like.
'
' SHORT MANUAL: Select desired font from combo list, use the mouse or
' arrow keys to move around in character map and see magnified characters.
' Double-click, or press key, or select and press Enter to put character
' in textbox. Press "Copy" to copy textbox contents to clipboard.
'

#COMPILE EXE
'-----------------------------------------------------------------
' Equates:  98
'-----------------------------------------------------------------
%WINAPI                                         = 1
%TRUE                                           = 1
%FALSE                                          = 0
%NULL                                           = 0
%LF_FACESIZE                                    = 32
%Gray                                           = &H808080???
%HEAP_ZERO_MEMORY                               = 8
%LR_LOADMAP3DCOLORS                             = &H00001000
%MAX_PATH                                       = 260  ' max. length of full pathname
%SRCCOPY                                        = &H00CC0020 ' (DWORD) dest = source
%TMPF_FIXED_PITCH                               = &H01
%TMPF_VECTOR                                    = &H02
%TMPF_DEVICE                                    = &H08
%OUT_TT_PRECIS                                  = 4
%CLIP_DEFAULT_PRECIS                            = 0
%DEFAULT_QUALITY                                = 0
%FF_DONTCARE                                    = 0    '  Don't care or don't know.
%TRUETYPE_FONTTYPE                              = &H4
%TRANSPARENT                                    = 1
%NULL_BRUSH                                     = 5
%PS_SOLID                                       = 0
%LOGPIXELSY                                     = 90   ' Logical pixels/inch in Y
%SW_HIDE                                        = 0
%SW_SHOW                                        = 5
%VK_RETURN                                      = &H0D
%VK_LEFT                                        = &H25
%VK_UP                                          = &H26
%VK_RIGHT                                       = &H27
%VK_DOWN                                        = &H28
%WM_DESTROY                                     = &H2
%WM_SETFOCUS                                    = &H7
%WM_KILLFOCUS                                   = &H8
%WM_PAINT                                       = &HF
%WM_ERASEBKGND                                  = &H14
%WM_DRAWITEM                                    = &H2B
%WM_SETFONT                                     = &H30
%WM_GETDLGCODE                                  = &H87
%WM_KEYDOWN                                     = &H100
%WM_CHAR                                        = &H102
%WM_INITDIALOG                                  = &H110
%WM_COMMAND                                     = &H111
%WM_MOUSEMOVE                                   = &H200
%WM_LBUTTONDOWN                                 = &H201
%WM_LBUTTONUP                                   = &H202
%WM_LBUTTONDBLCLK                               = &H203
%WM_COPY                                        = &H301
%MK_LBUTTON                                     = &H0001
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CLIPCHILDREN                                = &H02000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_VSCROLL                                     = &H00200000
%WS_SYSMENU                                     = &H00080000
%WS_TABSTOP                                     = &H00010000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_EX_CLIENTEDGE                               = &H00000200
%CS_DBLCLKS                                     = &H8
%CS_PARENTDC                                    = &H80
%ODA_DRAWENTIRE                                 = &H1
%ODA_SELECT                                     = &H2
%ODA_FOCUS                                      = &H4
%ODS_SELECTED                                   = &H0001
%HWND_DESKTOP                                   = 0
%DT_CENTER                                      = &H1
%DT_VCENTER                                     = &H4
%DT_SINGLELINE                                  = &H20
%DT_NOPREFIX                                    = &H800
%COLOR_WINDOW                                   = 5
%COLOR_WINDOWTEXT                               = 8
%COLOR_BTNFACE                                  = 15
%COLOR_INFOTEXT                                 = 23
%COLOR_INFOBK                                   = 24
%IDC_ARROW                                      = 32512&
%IDCANCEL                                       = 2
%ES_AUTOHSCROLL                                 = &H80&
%ES_NOHIDESEL                                   = &H100&
%EM_SETSEL                                      = &HB1
%EM_REPLACESEL                                  = &HC2
%BN_CLICKED                                     = 0
%SS_CENTER                                      = &H00000001
%SS_SUNKEN                                      = &H00001000
%DLGC_WANTALLKEYS                               = &H4    '  Control wants all keys
%CBN_SELENDOK                                   = 9
%CBS_DROPDOWNLIST                               = &H3&
%CBS_OWNERDRAWFIXED                             = &H10&
%CBS_SORT                                       = &H100&
%CBS_HASSTRINGS                                 = &H200&
%CBS_DISABLENOSCROLL                            = &H800&
%CB_ADDSTRING                                   = &H143
%CB_GETLBTEXT                                   = &H148
%CB_RESETCONTENT                                = &H14B
%CB_SELECTSTRING                                = &H14D
%CB_GETITEMDATA                                 = &H150
%CB_SETITEMDATA                                 = &H151
%CB_GETDROPPEDWIDTH                             = &H15F
%CB_SETDROPPEDWIDTH                             = &H160
%IMAGE_BITMAP                                   = 0
%LF_FULLFACESIZE                                = 64

'-----------------------------------------------------------------
' TYPE and UNION structures:  11
'-----------------------------------------------------------------
TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE POINTAPI
  x AS LONG
  y AS LONG
END TYPE

TYPE SIZEL
  cx AS LONG
  cy AS LONG
END TYPE

TYPE tagMSG
  hwnd AS DWORD
  message AS DWORD
  wParam AS LONG
  lParam AS LONG
  time AS DWORD
  pt AS POINTAPI
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    style AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

TYPE TEXTMETRIC
  tmHeight AS LONG
  tmAscent AS LONG
  tmDescent AS LONG
  tmInternalLeading AS LONG
  tmExternalLeading AS LONG
  tmAveCharWidth AS LONG
  tmMaxCharWidth AS LONG
  tmWeight AS LONG
  tmOverhang AS LONG
  tmDigitizedAspectX AS LONG
  tmDigitizedAspectY AS LONG
  tmFirstChar AS BYTE
  tmLastChar AS BYTE
  tmDefaultChar AS BYTE
  tmBreakChar AS BYTE
  tmItalic AS BYTE
  tmUnderlined AS BYTE
  tmStruckOut AS BYTE
  tmPitchAndFamily AS BYTE
  tmCharSet AS BYTE
END TYPE

TYPE NEWTEXTMETRIC
  tmHeight AS LONG
  tmAscent AS LONG
  tmDescent AS LONG
  tmInternalLeading AS LONG
  tmExternalLeading AS LONG
  tmAveCharWidth AS LONG
  tmMaxCharWidth AS LONG
  tmWeight AS LONG
  tmOverhang AS LONG
  tmDigitizedAspectX AS LONG
  tmDigitizedAspectY AS LONG
  tmFirstChar AS BYTE
  tmLastChar AS BYTE
  tmDefaultChar AS BYTE
  tmBreakChar AS BYTE
  tmItalic AS BYTE
  tmUnderlined AS BYTE
  tmStruckOut AS BYTE
  tmPitchAndFamily AS BYTE
  tmCharSet AS BYTE
  ntmFlags AS DWORD
  ntmSizeEM AS DWORD
  ntmCellHeight AS DWORD
  ntmAveWidth AS DWORD
END TYPE

TYPE LOGFONT
  lfHeight AS LONG
  lfWidth AS LONG
  lfEscapement AS LONG
  lfOrientation AS LONG
  lfWeight AS LONG
  lfItalic AS BYTE
  lfUnderline AS BYTE
  lfStrikeOut AS BYTE
  lfCharSet AS BYTE
  lfOutPrecision AS BYTE
  lfClipPrecision AS BYTE
  lfQuality AS BYTE
  lfPitchAndFamily AS BYTE
  lfFaceName AS ASCIIZ * %LF_FACESIZE
END TYPE

TYPE ENUMLOGFONT
  elfLogFont AS LOGFONT
  elfFullName AS ASCIIZ * %LF_FULLFACESIZE
  elfStyle AS ASCIIZ * %LF_FACESIZE
END TYPE

TYPE PAINTSTRUCT
  hDC AS DWORD
  fErase AS LONG
  rcPaint AS RECT
  fRestore AS LONG
  fIncUpdate AS LONG
  rgbReserved(0 TO 31) AS BYTE
END TYPE

TYPE DRAWITEMSTRUCT
  CtlType AS DWORD
  CtlID AS DWORD
  itemID AS DWORD
  itemAction AS DWORD
  itemState AS DWORD
  hwndItem AS LONG
  hDC AS DWORD
  rcItem AS RECT
  itemData AS DWORD
END TYPE

'-----------------------------------------------------------------
' Declared Functions:  54
'-----------------------------------------------------------------
DECLARE FUNCTION BeginPaint LIB "USER32.DLL" ALIAS "BeginPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION BitBlt LIB "GDI32.DLL" ALIAS "BitBlt" (BYVAL hDestDC AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hSrcDC AS DWORD, BYVAL xSrc AS LONG, BYVAL ySrc AS LONG, _
                 BYVAL dwRop AS DWORD) AS LONG
DECLARE FUNCTION CreateCompatibleBitmap LIB "GDI32.DLL" ALIAS "CreateCompatibleBitmap" (BYVAL hdc AS DWORD, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG) AS DWORD
DECLARE FUNCTION CreateCompatibleDC LIB "GDI32.DLL" ALIAS "CreateCompatibleDC" (BYVAL hdc AS DWORD) AS DWORD
DECLARE FUNCTION CreateFont LIB "GDI32.DLL" ALIAS "CreateFontA" (BYVAL nHeight AS LONG, BYVAL nWidth AS LONG, BYVAL nEscapement AS LONG, BYVAL nOrientation AS LONG, BYVAL fnWeight AS LONG, BYVAL fdwItalic AS DWORD, _
        BYVAL fdwUnderline AS DWORD, BYVAL fdwStrikeOut AS DWORD, BYVAL fdwCharSet AS DWORD, BYVAL fdwOutputPrecision AS DWORD, BYVAL fdwClipPrecision AS DWORD, BYVAL fdwQuality AS DWORD, _
        BYVAL fdwPitchAndFamily AS DWORD, lpszFace AS ASCIIZ) AS DWORD
DECLARE FUNCTION CreatePen LIB "GDI32.DLL" ALIAS "CreatePen" (BYVAL nPenStyle AS LONG, BYVAL nWidth AS LONG, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION CreateSolidBrush LIB "GDI32.DLL" ALIAS "CreateSolidBrush" (BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION DeleteDC LIB "GDI32.DLL" ALIAS "DeleteDC" (BYVAL hdc AS DWORD) AS LONG
DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION DrawFocusRect LIB "USER32.DLL" ALIAS "DrawFocusRect" (BYVAL hDC AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION DrawState LIB "USER32.DLL" ALIAS "DrawStateA" (BYVAL hDC AS DWORD, BYVAL hBrush AS DWORD, BYVAL lpDrawStateProc AS DWORD, BYVAL lParam AS LONG, BYVAL wParam AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL cx AS LONG, _
                 BYVAL cy AS LONG, BYVAL fuFlags AS DWORD) AS LONG
DECLARE FUNCTION DrawText LIB "USER32.DLL" ALIAS "DrawTextA" (BYVAL hDC AS DWORD, lpStr AS ASCIIZ, BYVAL nCount AS LONG, lpRect AS RECT, BYVAL uFormat AS DWORD) AS LONG
DECLARE FUNCTION EndPaint LIB "USER32.DLL" ALIAS "EndPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION EnumFontFamilies LIB "GDI32.DLL" ALIAS "EnumFontFamiliesA" (BYVAL hdc AS DWORD, lpszFamily AS ASCIIZ, BYVAL lpEnumFontFamProc AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION FillRect LIB "USER32.DLL" ALIAS "FillRect" (BYVAL hDC AS DWORD, lpRect AS RECT, BYVAL hBrush AS DWORD) AS LONG
DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" (BYVAL hInst AS DWORD, lpszClass AS ASCIIZ, lpWndClass AS WNDCLASSEX) AS LONG
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetDC LIB "USER32.DLL" ALIAS "GetDC" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetDeviceCaps LIB "GDI32.DLL" ALIAS "GetDeviceCaps" (BYVAL hdc AS DWORD, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS LONG
DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" () AS DWORD
DECLARE FUNCTION GetModuleHandle LIB "KERNEL32.DLL" ALIAS "GetModuleHandleA" (lpModuleName AS ASCIIZ) AS DWORD
DECLARE FUNCTION GetParent LIB "USER32.DLL" ALIAS "GetParent" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetProcessHeap LIB "KERNEL32.DLL" ALIAS "GetProcessHeap" () AS LONG
DECLARE FUNCTION GetStockObject LIB "GDI32.DLL" ALIAS "GetStockObject" (BYVAL nIndex AS LONG) AS DWORD
DECLARE FUNCTION GetSysColor LIB "USER32.DLL" ALIAS "GetSysColor" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetSysColorBrush LIB "USER32.DLL" ALIAS "GetSysColorBrush" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetTextExtentPoint32 LIB "GDI32.DLL" ALIAS "GetTextExtentPoint32A" (BYVAL hdc AS DWORD, lpsz AS ASCIIZ, BYVAL cbString AS LONG, lpSize AS SIZEL) AS LONG
DECLARE FUNCTION HeapAlloc LIB "KERNEL32.DLL" ALIAS "HeapAlloc" (BYVAL hHeap AS DWORD, BYVAL dwFlags AS DWORD, BYVAL dwBytes AS DWORD) AS DWORD
DECLARE FUNCTION HeapFree LIB "KERNEL32.DLL" ALIAS "HeapFree" (BYVAL hHeap AS DWORD, BYVAL dwFlags AS DWORD, BYVAL lpMem AS DWORD) AS LONG
DECLARE FUNCTION InvalidateRect LIB "USER32.DLL" ALIAS "InvalidateRect" (BYVAL hWnd AS DWORD, lpRect AS RECT, BYVAL bErase AS LONG) AS LONG
DECLARE FUNCTION InvertRect LIB "USER32.DLL" ALIAS "InvertRect" (BYVAL hDC AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION IsWindowVisible LIB "USER32.DLL" ALIAS "IsWindowVisible" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION LineTo LIB "GDI32.DLL" ALIAS "LineTo" (BYVAL hdc AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" (BYVAL hInstance AS DWORD, lpCursorName AS ASCIIZ) AS DWORD
DECLARE FUNCTION LoadImage LIB "USER32.DLL" ALIAS "LoadImageA" (BYVAL hInst AS DWORD, lpsz AS ASCIIZ, BYVAL uType AS DWORD, BYVAL cxDesired AS LONG, BYVAL cyDesired AS LONG, BYVAL fuLoad AS DWORD) AS DWORD
DECLARE FUNCTION MoveToEx LIB "GDI32.DLL" ALIAS "MoveToEx" (BYVAL hdc AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION MoveWindow LIB "USER32.DLL" ALIAS "MoveWindow" (BYVAL hWnd AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL bRepaint AS LONG) AS LONG
DECLARE FUNCTION Rectangle LIB "GDI32.DLL" ALIAS "Rectangle" (BYVAL hdc AS DWORD, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" (pcWndClassEx AS WNDCLASSEX) AS WORD
DECLARE FUNCTION ReleaseCapture LIB "USER32.DLL" ALIAS "ReleaseCapture" () AS LONG
DECLARE FUNCTION ReleaseDC LIB "USER32.DLL" ALIAS "ReleaseDC" (BYVAL hWnd AS DWORD, BYVAL hDC AS DWORD) AS LONG
DECLARE FUNCTION SelectObject LIB "GDI32.DLL" ALIAS "SelectObject" (BYVAL hdc AS DWORD, BYVAL hObject AS DWORD) AS DWORD
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetBkColor LIB "GDI32.DLL" ALIAS "SetBkColor" (BYVAL hdc AS DWORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION SetBkMode LIB "GDI32.DLL" ALIAS "SetBkMode" (BYVAL hdc AS DWORD, BYVAL nBkMode AS LONG) AS LONG
DECLARE FUNCTION SetCapture LIB "USER32.DLL" ALIAS "SetCapture" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetTextColor LIB "GDI32.DLL" ALIAS "SetTextColor" (BYVAL hdc AS DWORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION ShowCursor LIB "USER32.DLL" ALIAS "ShowCursor" (BYVAL bShow AS LONG) AS LONG
DECLARE FUNCTION ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" (BYVAL hWnd AS DWORD, BYVAL nCmdShow AS LONG) AS LONG
DECLARE FUNCTION TextOut LIB "GDI32.DLL" ALIAS "TextOutA" (BYVAL hdc AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, lpString AS ASCIIZ, BYVAL nCount AS LONG) AS LONG
DECLARE FUNCTION UpdateWindow LIB "USER32.DLL" ALIAS "UpdateWindow" (BYVAL hWnd AS DWORD) AS LONG

'-----------------------------------------------------------------
' Functions:  1  (begins with declarations)
'-----------------------------------------------------------------
DECLARE FUNCTION MoveTo (BYVAL hDC AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
FUNCTION MoveTo (BYVAL hDC AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
    FUNCTION = MoveToEx(hDC, x, y, BYVAL %NULL)
END FUNCTION

#RESOURCE "CHARMAP2.PBR"  '<- with program icon, bitmap for combo and version info
#INCLUDE "WINLIFT.INC"

'minimal RC file:            (all can be downloaded from address above)
'TT BITMAP TT.BMP
'PROGRAM ICON CHARMAP2.ICO
'--------------------------------------------------------------------
%CHM_LABEL   = 610
%CHM_VIEWER  = 620
%CHM_CHARMAP = 630
%CHM_COMBO1  = 640
%CHM_TEXT    = 650
%CHM_COPY    = 660
'--------------------------------------------------------------------
TYPE CHARMAPDATA         'dialog specific variables, like private globals..
  hCharMap     AS DWORD
  hViewer      AS DWORD
  CursorShown  AS LONG
  hMemDC       AS DWORD
  hBit         AS DWORD
  hFont        AS DWORD
  hFontViewer  AS DWORD
  hCombo       AS DWORD
  hTTbmp       AS DWORD
  WaCha        AS LONG
  WaCX         AS LONG
  WaCY         AS LONG
  WaChaOld     AS LONG
  rr           AS RECT
END TYPE

GLOBAL hDlgCmap AS DWORD 'sometimes one global makes things a lot easier..
'--------------------------------------------------------------------
DECLARE CALLBACK FUNCTION chmDlgProc() AS LONG
DECLARE FUNCTION chmEnumCharSet (elf AS ENUMLOGFONT, ntm AS NEWTEXTMETRIC, _
                                 BYVAL FontType AS LONG, CharSet AS LONG) AS LONG
DECLARE FUNCTION chmEnumFontFamProc(lf AS LOGFONT, tm AS TEXTMETRIC, _
                                    BYVAL FontType AS LONG, hWnd AS DWORD) AS LONG
DECLARE FUNCTION chmMakeFontEx(BYVAL FontName AS STRING, BYVAL PointSize AS LONG, BYVAL fBold AS LONG, _
                               BYVAL fItalic AS LONG, BYVAL fUnderline AS LONG) AS DWORD
DECLARE FUNCTION chmMapProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                            BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION chmViewerProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                               BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION ComboDrawFontProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                                   BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

DECLARE SUB chmDrawCharMap(BYVAL hWnd AS DWORD, BYVAL hDC AS DWORD)
DECLARE SUB chmDrawRedRect(BYVAL hDC AS DWORD)
DECLARE SUB chmFillFontCombo(BYVAL hWnd AS DWORD)
DECLARE SUB chmMoveViewer(BYVAL hWnd AS DWORD)

'
' Main entrance - create dialog and controls, etc
'
FUNCTION WINMAIN (BYVAL hInst AS DWORD, BYVAL hPrevInstance AS DWORD, _
                  BYVAL lpCmdLine AS ASCIIZ PTR, BYVAL iCmdShow AS LONG) AS LONG

  LOCAL I AS LONG, cm AS CHARMAPDATA PTR, szName AS ASCIIZ * 80, wc AS WNDCLASSEX

  DIALOG NEW 0, "PB Character Map",,, 391, 117, %WS_CAPTION OR %WS_CLIPCHILDREN OR _
                                                %WS_MINIMIZEBOX OR %WS_SYSMENU, 0 TO hDlgCmap
  DIALOG SET ICON hDlgCmap, "PROGRAM"

  cm = HeapAlloc(GetProcessHeap(), %HEAP_ZERO_MEMORY, SIZEOF(@cm)) 'allocate memory for structure
  IF cm THEN
     DIALOG SET USER hDlgCmap, 1, cm 'let's use PB/WIN 7's new feature to store mem in user area
  ELSE
     EXIT FUNCTION
  END IF

  szName = "CharGrid"  ' simple custom control grid for charmap
  wc.cbSize = LEN(wc)  ' could use a subclassed label too, but this is better, IMO..
  IF GetClassInfoEx(GetModuleHandle(""), szName, wc) = 0 THEN 'if not already registered
     wc.cbSize            = SIZEOF(wc)  
     wc.style             = %CS_DBLCLKS OR %CS_PARENTDC
     wc.lpfnWndProc       = CODEPTR(chmMapProc)
     wc.hInstance         = hInst
     wc.hCursor           = LoadCursor(%NULL, BYVAL %IDC_ARROW)
     wc.lpszClassName     = VARPTR(szName)

     IF RegisterClassEx(wc) = 0 THEN EXIT FUNCTION
  END IF
  CONTROL ADD "CharGrid", hDlgCmap, %CHM_CHARMAP,  "", 3, 20, 384, 93, _
              %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, %WS_EX_CLIENTEDGE
  CONTROL HANDLE hDlgCmap, %CHM_CHARMAP TO @cm.hCharMap

  szName = "CharViewer" ' another custom control as viewer
  wc.cbSize = LEN(wc)
  IF GetClassInfoEx(GetModuleHandle(""), szName, wc) = 0 THEN 'if not already registered
     wc.style             = %CS_DBLCLKS OR %CS_PARENTDC
     wc.lpfnWndProc       = CODEPTR(chmViewerProc)
     wc.hInstance         = hInst
     wc.hCursor           = LoadCursor(%NULL, BYVAL %IDC_ARROW)
     wc.lpszClassName     = VARPTR(szName)

     IF RegisterClassEx(wc) = 0 THEN EXIT FUNCTION
  END IF
  CONTROL ADD "CharViewer", hDlgCmap, %CHM_VIEWER, "", 6, 4, 24, 24, %WS_CHILD
  CONTROL HANDLE hDlgCmap, %CHM_VIEWER TO @cm.hViewer

  CONTROL ADD LABEL, hDlgCmap, %CHM_LABEL, "", 6, 4, 75, 13, %SS_CENTER OR %SS_SUNKEN
  CONTROL ADD COMBOBOX, hDlgCmap, %CHM_COMBO1,, 90, 3, 120, 120, _
                       %CBS_OWNERDRAWFIXED OR %CBS_HASSTRINGS OR %CBS_DROPDOWNLIST OR _
                       %CBS_SORT OR %WS_TABSTOP OR %CBS_DISABLENOSCROLL OR %WS_VSCROLL
  CONTROL HANDLE hDlgCmap, %CHM_COMBO1 TO @cm.hCombo

  CONTROL SEND hDlgCmap, %CHM_COMBO1, %CB_GETDROPPEDWIDTH, 0, 0 TO I  'get list width
  CONTROL SEND hDlgCmap, %CHM_COMBO1, %CB_SETDROPPEDWIDTH, I + 40, 0  'increase list width

  @cm.hTTbmp = LoadImage(hInst, "TT", %IMAGE_BITMAP, 0, 0, %LR_LOADMAP3DCOLORS) 'TrueType bitmap..
  chmFillFontCombo @cm.hCombo ' fill combo with available fonts via enumeration routine

  szName = "Times New Roman"  ' start with this font
  SendMessage @cm.hCombo, %CB_SELECTSTRING, -1, VARPTR(szName) ' search and select

  CONTROL ADD TEXTBOX, hDlgCmap, %CHM_TEXT, "", 214, 3, 64, 13, _
              %WS_TABSTOP OR %ES_NOHIDESEL OR %ES_AUTOHSCROLL, %WS_EX_CLIENTEDGE
  CONTROL ADD BUTTON, hDlgCmap, %CHM_COPY, "&Copy",  284, 2, 50, 16
  CONTROL ADD BUTTON, hDlgCmap, %IDCANCEL, "Clo&se", 338, 2, 50, 16


  @cm.hFont  = chmMakeFontEx(szName, 11, 0, 0, 0)  'create and set font
  IF @cm.hFont THEN
     SendMessage @cm.hCharMap, %WM_SETFONT, @cm.hFont, 0
     SendMessage GetDlgItem(hDlgCmap, %CHM_TEXT), %WM_SETFONT, @cm.hFont, 0
  END IF

  @cm.hFontViewer = chmMakeFontEx(szName, 22, 0, 0, 0) 'same but bigger in magnifier
  IF @cm.hFontViewer THEN
     SendMessage @cm.hViewer, %WM_SETFONT, @cm.hFontViewer, 0
  END IF

  @cm.WaCha = 65 'initial position, character "A"

  IF skInitEngine("Futura.sks", "") THEN
     CALL skSkinWindow(hDlgCmap, "Dock|Undock|Minimize|Maximize|Restore|Close")
  END IF

  DIALOG SHOW MODELESS hDlgCmap CALL chmDlgProc

  DO
     DIALOG DOEVENTS
  LOOP UNTIL hDlgCmap = 0 ' message pump while dialog handle has a value

END FUNCTION

'
' Main callback
'
CALLBACK FUNCTION chmDlgProc() AS LONG

  LOCAL hDC AS DWORD, cm AS CHARMAPDATA PTR, szName AS ASCIIZ * %MAX_PATH
  DIALOG GET USER CBHNDL, 1 TO cm

  SELECT CASE CBMSG
     CASE %WM_INITDIALOG
        @cm.CursorShown  = %TRUE            'cursor is shown
        hDC          = GetDc(@cm.hCharMap)
        chmDrawCharMap @cm.hCharMap, hDC    'draw entire character map
        ReleaseDc @cm.hCharMap, hDC
        chmMoveViewer @cm.hCharMap          'set initial position
        MOUSEPTR 1
        DIALOG DOEVENTS

     CASE %WM_DESTROY                       'clean up on exit
        IF @cm.hFontViewer  THEN DeleteObject @cm.hFontViewer
        IF @cm.hTTbmp THEN DeleteObject @cm.hTTbmp
        IF @cm.hFont  THEN DeleteObject @cm.hFont
        IF @cm.hBit   THEN DeleteObject SelectObject(@cm.hMemDC, @cm.hBit)
        IF @cm.hMemDC THEN DeleteDC @cm.hMemDC
        IF cm         THEN HeapFree GetProcessHeap(), 0, BYVAL cm
        hDlgCmap = 0  ' reset this variable to break message loop on exit

     CASE %WM_COMMAND
        SELECT CASE CBCTL
           CASE %IDCANCEL
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 DIALOG END CBHNDL
              END IF
 
           CASE %CHM_COPY
              CONTROL SEND CBHNDL, %CHM_TEXT, %EM_SETSEL, 0, -1
              CONTROL SEND CBHNDL, %CHM_TEXT, %WM_COPY, 0, 0
              CONTROL SEND CBHNDL, %CHM_TEXT, %EM_SETSEL, 0, 0

           CASE %CHM_COMBO1
              IF CBCTLMSG = %CBN_SELENDOK THEN
                 COMBOBOX GET TEXT CBHNDL, %CHM_COMBO1 TO szName       'get font name
                 SetFocus @cm.hCharMap                                 'set focus to charmap
                 MOUSEPTR 11                                       'set hourglass mouse
                 IF @cm.hFont THEN DeleteObject @cm.hFont                  'delete old font
                 @cm.hFont = chmMakeFontEx(szName, 10, 0, 0, 0)      'create new
                 SendMessage @cm.hCharMap, %WM_SETFONT, @cm.hFont, 0       'and set it to controls
                 SendMessage GetDlgItem(CBHNDL, %CHM_TEXT), %WM_SETFONT, @cm.hFont, 0
                 InvalidateRect GetDlgItem(CBHNDL, %CHM_TEXT), BYVAL %NULL, 0
                 UpdateWindow GetDlgItem(CBHNDL, %CHM_TEXT)

                 IF @cm.hFontViewer THEN DeleteObject @cm.hFontViewer      'same but bigger, for magnifier
                 @cm.hFontViewer = chmMakeFontEx(szName, 24, 0, 0, 0)
                 SendMessage @cm.hViewer, %WM_SETFONT, @cm.hFontViewer, 0

                 hDC = GetDc(@cm.hCharMap)
                 chmDrawCharMap @cm.hCharMap, hDC                         'redraw character map
                 ReleaseDc @cm.hCharMap, hDC
                 InvalidateRect @cm.hCharMap, BYVAL %NULL, 0 : UpdateWindow @cm.hCharMap
                 MOUSEPTR 1
              END IF

        END SELECT

     CASE %WM_DRAWITEM 'Pass this one on to ComboDrawFontProc
        IF CBWPARAM = %CHM_COMBO1 THEN
           FUNCTION = ComboDrawFontProc (@cm.hCombo, CBMSG, CBWPARAM, CBLPARAM)
        END IF

  END SELECT
END FUNCTION

'
' Character map control procedure
'
FUNCTION chmMapProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                    BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

  LOCAL cm AS CHARMAPDATA PTR, r AS RECT, szName AS ASCIIZ * 2
  LOCAL iMsg AS LONG, pMsg AS TAGMSG PTR
  DIALOG GET USER hDlgCmap, 1 TO cm

  SELECT CASE wMsg
     CASE %WM_GETDLGCODE 'make sure we can trap some keys
        pMsg = lParam
        IF pMsg > 0 THEN iMsg = @pMsg.Message
        IF iMsg = %WM_KEYDOWN THEN ' these are the keys we want to trap..
           SELECT CASE @pMsg.wParam
              CASE %VK_LEFT, %VK_RIGHT, %VK_UP, %VK_DOWN, %VK_RETURN
                 FUNCTION = %DLGC_WANTALLKEYS : EXIT FUNCTION
           END SELECT
        END IF
 
     CASE %WM_CHAR ' for proper character codes
        IF wParam > 31 AND wParam < 256 THEN  ' move to matching character on keydown
           @cm.WaCha = wParam
           szName = CHR$(@cm.WaCha)

           chmMoveViewer @cm.hCharMap
           IF IsWindowVisible(@cm.hViewer) = 0 THEN
              IF GetFocus <> @cm.hCharMap THEN SetFocus @cm.hCharMap
              ShowWindow @cm.hViewer, %SW_SHOW
              InvalidateRect @cm.hCharMap, BYVAL %NULL, 0 : UpdateWindow @cm.hCharMap
           END IF
           EXIT FUNCTION
        END IF

     CASE %WM_KEYDOWN
         SELECT CASE wParam
           CASE %VK_LEFT, %VK_RIGHT, %VK_UP, %VK_DOWN, %VK_RETURN  'trap arrow keys and Enter here
              IF wParam = %VK_LEFT THEN
                 DECR @cm.WaCha
              ELSEIF wParam = %VK_RIGHT THEN
                 INCR @cm.WaCha
              ELSEIF wParam = %VK_UP THEN
                 IF @cm.WaCha > 63 THEN @cm.WaCha = @cm.WaCha - 32
              ELSEIF wParam = %VK_DOWN THEN
                 IF @cm.WaCha < 224 THEN @cm.WaCha = @cm.WaCha + 32
              ELSEIF wParam = %VK_RETURN THEN                      'insert on Enter key
                 szName = CHR$(@cm.WaCha)
                 CONTROL SEND hDlgCmap, %CHM_TEXT, %EM_REPLACESEL, %TRUE, VARPTR(szName)
                 EXIT FUNCTION
              END IF
              IF @cm.WaCha > 255 THEN @cm.WaCha = 255                    'check boundaries
              IF @cm.WaCha < 32 THEN @cm.WaCha = 32

              chmMoveViewer @cm.hCharMap                                 'move the viewer
              IF IsWindowVisible(@cm.hViewer) = 0 THEN                   'if viewer not visible
                 IF GetFocus <> @cm.hCharMap THEN SetFocus @cm.hCharMap  'just in case..
                 ShowWindow @cm.hViewer, %SW_SHOW                        'show viewer
                 InvalidateRect @cm.hCharMap, BYVAL %NULL, 0 : UpdateWindow @cm.hCharMap 'refresh map to clean up garbage
              END IF
              EXIT FUNCTION
        END SELECT

     CASE %WM_KILLFOCUS              'reset magnifier on lost focus
        ShowWindow @cm.hViewer, %SW_HIDE
        InvalidateRect @cm.hCharMap, BYVAL %NULL, 0 : UpdateWindow @cm.hCharMap
        FUNCTION = 0 : EXIT FUNCTION

     CASE %WM_SETFOCUS                'set magnifier on focus, but not at start or from combo
        IF wParam = @cm.hCombo OR wParam = GetParent(hWnd) THEN EXIT FUNCTION
        chmMoveViewer @cm.hCharMap
        IF IsWindowVisible(@cm.hViewer) = 0 THEN
           ShowWindow @cm.hViewer, %SW_SHOW
           InvalidateRect @cm.hCharMap, BYVAL %NULL, 0 : UpdateWindow @cm.hCharMap
        END IF
        FUNCTION = 0 : EXIT FUNCTION

     CASE %WM_LBUTTONDOWN             'trap left button down (click)
        SetCapture hWnd
        IF IsWindowVisible(@cm.hViewer) = 0 THEN
           IF @cm.CursorShown THEN                'if cursor is shown
              @cm.CursorShown = 0 : ShowCursor 0  'hide it..
           END IF
           IF GetFocus <> hWnd THEN SetFocus hWnd
        END IF
        GetClientRect hWnd, r  'get coordinates
        @cm.WaCX  = LOWRD(lParam) \ (r.nRight / 32)
        @cm.WaCY  = HIWRD(lParam) \ (r.nBottom / 7) + 1
        @cm.WaCha = @cm.WaCY * 32 + @cm.WaCX
        chmMoveViewer hWnd
        IF IsWindowVisible(@cm.hViewer) = 0 THEN
           ShowWindow @cm.hViewer, %SW_SHOW
           InvalidateRect @cm.hCharMap, BYVAL %NULL, 0 : UpdateWindow @cm.hCharMap
        END IF
        FUNCTION = 0 : EXIT FUNCTION  'bail out..

     CASE %WM_MOUSEMOVE
        IF wParam = %MK_LBUTTON THEN
           GetClientRect hWnd, r  'get and check coordinates
           IF LOWRD(lParam) > 0 AND LOWRD(lParam) < r.nRight AND _
              HIWRD(lParam) > 0 AND HIWRD(lParam) < r.nBottom THEN
                 IF @cm.CursorShown THEN 'if cursor is shown and mouse is inside control
                    @cm.CursorShown = 0 : ShowCursor 0            'then hide it..
                 END IF
                 @cm.WaCX  = LOWRD(lParam) \ (r.nRight / 32)      'calculate positions
                 @cm.WaCY  = HIWRD(lParam) \ (r.nBottom / 7) + 1
                 @cm.WaCha = @cm.WaCY * 32 + @cm.WaCX                     'and selected character
                 chmMoveViewer hWnd
                 FUNCTION = 0 : EXIT FUNCTION
           ELSE
              IF @cm.CursorShown = 0 THEN  'if cursor is hidden and mouse is outside control
                 @cm.CursorShown = %TRUE : ShowCursor %TRUE       'then show it..
              END IF
           END IF
        END IF

     CASE %WM_LBUTTONDBLCLK          'put selected character in textbox on double-click
        IF wParam = %MK_LBUTTON THEN
           szName = CHR$(@cm.WaCha)
           CONTROL SEND hDlgCmap, %CHM_TEXT, %EM_REPLACESEL, %TRUE, VARPTR(szName)
        END IF

     CASE %WM_LBUTTONUP                             'when left button is released
        ReleaseCapture
        IF @cm.CursorShown = 0 THEN                     'if cursor is hidden
           @cm.CursorShown = %TRUE : ShowCursor %TRUE   'show it..
        END IF
        ShowWindow @cm.hViewer, %SW_HIDE
        InvalidateRect @cm.hCharMap, BYVAL %NULL, 0 : UpdateWindow @cm.hCharMap
        FUNCTION = 0 : EXIT FUNCTION  'bail out..

     CASE %WM_ERASEBKGND                            'we handle background ourselves, so..
        FUNCTION = 1 : EXIT FUNCTION

     CASE %WM_PAINT', %WM_PRINTCLIENT
        LOCAL ps AS PAINTSTRUCT
        GetClientRect @cm.hCharMap, r   'get coordinates
        BeginPaint hWnd, ps           'start paint procedure and use pre-created bitmap for better speed
        BitBlt ps.hDC, 0, 0, r.nRight, r.nBottom, @cm.hMemDC, 0, 0, %SRCCOPY
        IF IsWindowVisible(@cm.hViewer) = 0 THEN chmDrawRedRect ps.hDC 'if no magnifier, draw red selection rect
        EndPaint hWnd, ps             'end paint procedure
        FUNCTION = 0 : EXIT FUNCTION  'bail out..

  END SELECT

  FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'
' Draw the character map, using selected font
'
SUB chmDrawCharMap(BYVAL hWnd AS DWORD, BYVAL hDC AS DWORD)
  LOCAL I AS LONG, hPen AS DWORD
  LOCAL hBrush AS DWORD, hBrushOld AS DWORD, hFontOld AS DWORD
  LOCAL r AS RECT, txt AS STRING
  LOCAL cm AS CHARMAPDATA PTR

  DIALOG GET USER hDlgCmap, 1 TO cm

  IF @cm.hBit   THEN DeleteObject SelectObject(@cm.hMemDC, @cm.hBit)
  IF @cm.hMemDC THEN DeleteDC @cm.hMemDC                    'delete old memDC, if any

  GetClientRect hWnd, r                                     'get coordinates
  @cm.hMemDC = CreateCompatibleDC(hDC)                      'create global memDC
  @cm.hBit   = CreateCompatibleBitmap(hDC, r.nRight, r.nBottom)
  @cm.hBit   = SelectObject(@cm.hMemDC, @cm.hBit)
  hFontOld = SelectObject(@cm.hMemDC, @cm.hFont)            'use selected font
                                                            'CLEAR BACKGROUND
  hBrush = GetSysColorBrush(%COLOR_WINDOW)                  'use standard Window color
  hBrushOld = SelectObject(@cm.hMemDC, hBrush)              'Select brush into device context
  CALL FillRect(@cm.hMemDC, r, hBrush)                      'Paint background color rectangle
  CALL SelectObject(@cm.hMemDC, hBrushOld)                  'Select old brush back
                                                            'DRAW GRIDLINES
  hPen = CreatePen(%PS_SOLID, 1, GetSysColor(%COLOR_BTNFACE)) 'use light gray color
  hPen = SelectObject(@cm.hMemDC, hPen)
  FOR I = 1 TO 6                                            'draw horizontal lines
     MoveTo @cm.hMemDC, 0, I * r.nBottom / 7
     LineTo @cm.hMemDC, r.nRight, I * r.nBottom / 7
  NEXT
  FOR I = 1 TO 31                                           'draw vertical lines
     MoveTo @cm.hMemDC, I * r.nRight  / 32, 0
     LineTo @cm.hMemDC, I * r.nRight  / 32, r.nBottom
  NEXT
  DeleteObject SelectObject(@cm.hMemDC, hPen)

  LOCAL Ac AS LONG, Bc AS LONG, Cc AS LONG, lpSize AS SIZEL
  Cc = 32                       'start at number 32, space
  FOR Ac = 0 TO 6               'row by row
     FOR Bc = 0 TO 31           'with 32 characters in each
        txt = CHR$(Cc)
        CALL GetTextExtentPoint32(@cm.hMemDC, BYVAL STRPTR(txt), LEN(txt), lpSize)

        TextOut @cm.hMemDC, Bc * r.nRight  / 32 + (r.nRight  / 32 - lpSize.cx) / 2, _
                        Ac * r.nBottom /  7 + (r.nBottom /  7 - lpSize.cy) / 2, _
                        BYVAL STRPTR(txt), LEN(Txt) 'Draw text
        INCR Cc
        IF Cc > 255 THEN EXIT FOR
     NEXT
     IF Cc > 255 THEN EXIT FOR
  NEXT
  @cm.hFont = SelectObject(@cm.hMemDC, hFontOld) 'Select old font back

END SUB

'
' Move magnifier control (label) in grid
'
SUB chmMoveViewer(BYVAL hWnd AS DWORD)
  LOCAL cm AS CHARMAPDATA PTR
  DIALOG GET USER hDlgCmap, 1 TO cm

  IF @cm.WaCha= @cm.WaChaOld THEN EXIT SUB
  LOCAL W AS LONG, H AS LONG, X AS LONG, Y AS LONG, r AS RECT, txt AS STRING

  CONTROL GET LOC GetParent(hWnd), %CHM_CHARMAP TO X, Y '<- need this if big font is set..
  DIALOG UNITS GetParent(hWnd), X, Y TO PIXELS X, Y
  GetClientRect hWnd, r  'get coordinates
  @cm.WaCX = @cm.WaCha MOD 32
  @cm.WaCY = @cm.WaCha \ 32
  @cm.WaChaOld = @cm.WaCha

  IF @cm.WaCha = 38 THEN
     txt = CHR$(@cm.WaCha, @cm.WaCha)  'must double "&" character, otherwise we'll
  ELSE                         'get underscore (used as shortcut in Windows)
     txt = CHR$(@cm.WaCha)
  END IF
  CONTROL SET TEXT GetParent(hWnd), %CHM_LABEL, " Shortcut: Alt+0" & FORMAT$(@cm.WaCha)

  IF @cm.WaCX < 31 THEN 'small adjustments for rightmost and topmost positions
     W = r.nRight / 32 + 2  '(only used with red selection rectangle)
  ELSE
     W = r.nRight / 32
  END IF

  IF @cm.WaCY < 7 THEN
     H = r.nBottom / 7 + 2
  ELSE
     H = r.nBottom / 7
  END IF
                   'rr holds the coordinates for red selection rectangle
  @cm.rr.nLeft = @cm.WaCX * r.nRight / 32 : @cm.rr.nTop = (@cm.WaCY - 1) * r.nBottom / 7
  @cm.rr.nRight = @cm.rr.nLeft + W : @cm.rr.nBottom = @cm.rr.nTop + H


  MoveWindow @cm.hViewer, MAX&(X - 3, X + @cm.WaCX * r.nRight / 32 - 10), _
                      MAX&(Y - 4, Y + (@cm.WaCY - 1) * r.nBottom / 7 - 8), _
                      W + 20, H + 18, %TRUE
  InvalidateRect @cm.hViewer, BYVAL %NULL, 1

END SUB

'
' Draw a red, hollow frame around selected character
'
SUB chmDrawRedRect(BYVAL hDC AS DWORD)
  LOCAL hPen AS DWORD, hBrush AS DWORD, cm AS CHARMAPDATA PTR
  DIALOG GET USER hDlgCmap, 1 TO cm

  hPen   = CreatePen(%PS_SOLID, 2, RGB(255,0,0))          'create a red pen for frame
  hPen   = SelectObject(hDC, hPen)                        'Select pen into DC
  hBrush = SelectObject(hDC, GetStockObject(%NULL_BRUSH)) 'Select a hollow brush into DC
  Rectangle hDC, @cm.rr.nLeft, @cm.rr.nTop, @cm.rr.nRight, @cm.rr.nBottom 'draw the frame
  DeleteObject SelectObject(hDC, hPen)                    'Delete pen
  DeleteObject SelectObject(hDC, hBrush)                  'Delete brush
END SUB

'
' Create a desirable font and return its handle. Original code by Dave Navarro
' NOTE: enhanced with proper enumeration of character set via chmEnumFontDataProc
'
FUNCTION chmMakeFontEx(BYVAL FontName AS STRING, BYVAL PointSize AS LONG, BYVAL fBold AS LONG, _
                       BYVAL fItalic AS LONG, BYVAL fUnderline AS LONG) AS DWORD
  LOCAL hDC AS DWORD, CharSet AS LONG, CyPixels AS LONG

  hDC = GetDC(%HWND_DESKTOP)
    CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
    EnumFontFamilies hDC, BYVAL STRPTR(FontName), CODEPTR(chmEnumCharSet), BYVAL VARPTR(CharSet)
  ReleaseDC %HWND_DESKTOP, hDC
  PointSize = 0 - (PointSize * CyPixels) \ 72

  FUNCTION = CreateFont(PointSize, 0, _  'height, width(default=0)
             0, 0, _                     'escapement(angle), orientation
             fBold, _                    'weight (%FW_DONTCARE = 0, %FW_NORMAL = 400, %FW_BOLD = 700)
             fItalic, _                  'Italic
             fUnderline, _               'Underline
             %FALSE, _                   'StrikeThru
             CharSet, %OUT_TT_PRECIS, _
             %CLIP_DEFAULT_PRECIS, %DEFAULT_QUALITY, _
             %FF_DONTCARE , BYCOPY FontName)
END FUNCTION

'
' Get type of character set - ansi, symbol.. a must for some fonts.
'
FUNCTION chmEnumCharSet (elf AS ENUMLOGFONT, ntm AS NEWTEXTMETRIC, _
                         BYVAL FontType AS LONG, CharSet AS LONG) AS LONG
  CharSet = elf.elfLogFont.lfCharSet
END FUNCTION

'
' Fill a combo box with the names of all fonts of a certain type
'
SUB chmFillFontCombo(BYVAL hWnd AS DWORD)
  LOCAL hDC AS DWORD

  SendMessage hWnd, %CB_RESETCONTENT, 0, 0
  hDC = GetDC(%HWND_DESKTOP)
    EnumFontFamilies hDC, BYVAL %NULL, CODEPTR(chmEnumFontFamProc), BYVAL VARPTR(hWnd)
  ReleaseDC %HWND_DESKTOP, hDC
END SUB

'
' Enumerate all available fonts and add names to combobox Note the difference
' between how to enumerate them - %TMPF_FIXED_PITCH has the bit cleared..
' Here all fonts are added, but you can remove the kinds you don't need.
' %TMPF_FIXED_PITCH for fixed pitch fonts (like in PB edit)     (bit is zero)
' %TMPF_TRUETYPE OR %TMPF_VECTOR for True type and vector fonts (bit is set)
' %TMPF_DEVICE for device fonts, like printer. Often combined.  (bit is set)
'
FUNCTION chmEnumFontFamProc(lf AS LOGFONT, tm AS TEXTMETRIC, BYVAL FontType AS LONG, hWnd AS DWORD) AS LONG
  LOCAL i AS LONG

  IF (FontType AND %TRUETYPE_FONTTYPE) THEN        ' true type fonts
     i = SendMessage(hWnd , %CB_ADDSTRING, 0, VARPTR(lf.lfFaceName))
     SendMessage hWnd , %CB_SETITEMDATA, i, 1      ' set flag to use tt bitmap

  ELSEIF (FontType AND %TMPF_FIXED_PITCH) = 0 THEN ' <- check if bit is cleared!
     SendMessage hWnd , %CB_ADDSTRING, 0, VARPTR(lf.lfFaceName) ' fixed pitch fonts

  ELSEIF (FontType AND %TMPF_VECTOR) THEN
     SendMessage hWnd , %CB_ADDSTRING, 0, VARPTR(lf.lfFaceName) ' vector fonts

  ELSEIF (FontType AND %TMPF_DEVICE) THEN
     SendMessage hWnd , %CB_ADDSTRING, 0, VARPTR(lf.lfFaceName) ' device fonts

  ELSE
     SendMessage hWnd , %CB_ADDSTRING, 0, VARPTR(lf.lfFaceName) ' system, fonts - the rest..

  END IF

  FUNCTION = 1
END FUNCTION

'
' "Maignifier" procedure
'
FUNCTION chmViewerProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                       BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
  SELECT CASE wMsg
     CASE %WM_PAINT', %WM_PRINTCLIENT
        LOCAL hBrush AS DWORD, hPen AS DWORD, vFont AS DWORD, zTxt AS ASCIIZ * 2, _
              ps AS PAINTSTRUCT, rc AS rect, cm AS CHARMAPDATA PTR

        DIALOG GET USER hDlgCmap, 1 TO cm
        GetCLientRect hWnd, rc
        zTxt = CHR$(@cm.WaCha)

        BeginPaint hWnd, ps
          hBrush = SelectObject(ps.hDC, CreateSolidBrush(GetSysColor(%COLOR_INFOBK))) 'background color
          vFont = SelectObject(ps.hDC, @cm.hFontViewer)      'use created viewer font
          SetBkMode ps.hDC, %TRANSPARENT                     'transparent background mode
          SetTextColor ps.hDC, GetSysColor(%COLOR_INFOTEXT)  'default infotext color

          Rectangle ps.hDC, 0, 0, rc.nRight - 1, rc.nBottom - 1
          rc.nBottom = rc.nBottom - 2
          CALL DrawText(ps.hDC, zTxt, 1, rc, %DT_SINGLELINE OR %DT_CENTER OR %DT_VCENTER OR %DT_NOPREFIX)
          rc.nBottom = rc.nBottom + 2

          hPen = SelectObject(ps.hDC, CreatePen(%PS_SOLID, 1, %GRAY)) 'pen for shadow color
          MoveTo ps.hDC, 1, rc.nBottom - 1                            'move into position
          LineTo ps.hDC, rc.nRight, rc.nBottom - 1                    'draw bottom shadow line, dark gray
          MoveTo ps.hDC, rc.nRight - 1, 1                             'new position
          LineTo ps.hDC, rc.nRight - 1, rc.nBottom                    'draw right shadow line, dark gray

          DeleteObject SelectObject(ps.hDC, hPen)                     'select original back and delete
          DeleteObject SelectObject(ps.hDC, hBrush)                   'select original back and delete
          SelectObject ps.hDC, vFont  'no need to delete stock objects, only select original font back
        EndPaint hWnd, ps
        FUNCTION = 0 : EXIT FUNCTION

     CASE %WM_ERASEBKGND : FUNCTION = 1 : EXIT FUNCTION  'we paint background ourselves, so..

  END SELECT

  FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'
' Combobox DrawItem procedure
'
FUNCTION ComboDrawFontProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                   BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

  LOCAL I AS LONG, hBrush AS DWORD, hBrushOld AS DWORD, rct AS RECT
  LOCAL lpdis AS DRAWITEMSTRUCT PTR, zTxt AS ASCIIZ * 64, cm AS CHARMAPDATA PTR

  lpdis = lParam
  IF @lpdis.itemID = &HFFFFFFFF THEN EXIT FUNCTION
  DIALOG GET USER hDlgCmap, 1 TO cm

  SELECT CASE @lpdis.itemAction
     CASE %ODA_DRAWENTIRE, %ODA_SELECT
        'CLEAR BACKGROUND
        hBrush = CreateSolidBrush(GetSysColor(%COLOR_WINDOW)) 'Create a background brush
        hBrushOld = SelectObject(@lpdis.hDC, hBrush)      'Select brush into device context
        CALL FillRect(@lpdis.hDC, @lpdis.rcItem, hBrush)  'Paint background color rectangle
        CALL SelectObject(@lpdis.hDC, hBrushOld)          'Select old brush back
        CALL DeleteObject(hBrush)                         'Delete brush

        'DRAW TEXT
        CALL SetBkColor(@lpdis.hDC, GetSysColor(%COLOR_WINDOW))              'Set text Background
        CALL SetTextColor(@lpdis.hDC, GetSysColor(%COLOR_WINDOWTEXT))        'Set text color
        CALL SendMessage(hWnd, %CB_GETLBTEXT, @lpdis.itemID, VARPTR(zTxt))   'Get text
        CALL TextOut(@lpdis.hDC, 21, @lpdis.rcItem.ntop + 2, zTxt, LEN(zTxt))'Draw text

        'SELECTED ITEM
        IF (@lpdis.itemState AND %ODS_SELECTED) THEN     'if selected then
          CALL DrawFocusRect(@lpdis.hDC, @lpdis.rcItem)  'draw a focus rectangle around all
        END IF

        'PAINT TT BITMAP, IF TRUE TYPE FONT
        I = SendMessage(hWnd , %CB_GETITEMDATA, @lpdis.itemID, 0)
        IF I THEN
           CALL DrawState(@lpdis.hDC, 0, 0, @cm.hTTbmp, 0, 3, @lpdis.rcItem.ntop + 2, 0, 0, &H4)
        END IF

     CASE %ODA_FOCUS                                         'for selction in dropped list
        rct.nLeft   = 19 : rct.nRight = @lpdis.rcItem.nRight 'Set cordinates
        rct.ntop    = @lpdis.rcItem.ntop
        rct.nbottom = @lpdis.rcItem.nbottom
        CALL InvertRect(@lpdis.hDC, rct)                     'invert area around text only

  END SELECT

  FUNCTION = %TRUE
END FUNCTION
