' Note this example has been used as a template to use icon together with
' WinLIFT's skinned menu
' Search for %WM_SKGETMENUICON
'
'
' DrawMenu - a sample of how to include bitmaps in ownerdrawn menus.
' Public Domain by Borje Hagsten, October, 2000. Updated Feb, 2002.
' Free to use and modify, but as always, at own responsibility..  :)
'
' Update - February 13, 2001
' Changed a few DST_ values for DrawState in DrawMenuItem to DWORDS.
'
' Update - February 12, 2001
' Complete change of way to store menu item text. Now use a separate function
' for this, GetMenuTxt. Advantages - is cleaner and no more hassle with
' GetMenuItemInfo, which seems to behave differently depending on system.
' Win95/98, different versions of NT 4 and 5 - they all seem to behave
' differently. Think MS has managed to screw up real bad there..
'
' Files: DrawMenu.exe, DrawMenu.bas, DrawMenu.pbr, DrawMenu.rc and Toolbar.bmp
' The bmp contains some 16x16 bitmaps for the menu items. Drawmenu.zip can be
' downloaded from : http://www.algonet.se/~hagsten/pb/drawmenu.zip
'
' Many thanks to Fred Oxenby, Semen Matusovski, Paul Noble and Paul Squires
' for valuable tips and help with testing.
'
#COMPILE EXE
'#INCLUDE "WIN32API.INC"
'-----------------------------------------------------------------
' Equates:  49
'-----------------------------------------------------------------
%WINAPI                                         = 1
%TRUE                                           = 1
%FALSE                                          = 0
%NULL                                           = 0
%WM_USER                                        = &H400
%LR_LOADMAP3DCOLORS                             = &H00001000
%SRCCOPY                                        = &H00CC0020 ' (DWORD) dest = source
%VK_RETURN                                      = &H0D
%VK_CONTROL                                     = &H11
%VK_ESCAPE                                      = &H1B
%GWL_WNDPROC                                    = -4
%WM_DESTROY                                     = &H2
%WM_SIZE                                        = &H5
%WM_GETTEXTLENGTH                               = &HE
%WM_DRAWITEM                                    = &H2B
%WM_MEASUREITEM                                 = &H2C
%WM_CONTEXTMENU                                 = &H7B
%WM_KEYDOWN                                     = &H100
%WM_COMMAND                                     = &H111
%WM_INITMENUPOPUP                               = &H117
%WM_CUT                                         = &H300
%WM_COPY                                        = &H301
%WM_PASTE                                       = &H302
%SIZE_MINIMIZED                                 = 1
%WS_OVERLAPPED                                  = &H0
%WS_CHILD                                       = &H40000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_VSCROLL                                     = &H00200000
%WS_HSCROLL                                     = &H00100000
%WS_SYSMENU                                     = &H00080000
%WS_THICKFRAME                                  = &H00040000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_MAXIMIZEBOX                                 = &H00010000
%WS_OVERLAPPEDWINDOW                            = %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX
%WS_EX_CLIENTEDGE                               = &H00000200
%CS_DROPSHADOW                                  = &H00020000
%CF_TEXT                                        =  1
%MB_OK                                          = &H00000000&
%MF_ENABLED                                     = &H0&
%MF_GRAYED                                      = &H1&
%ES_MULTILINE                                   = &H4&
%ES_AUTOVSCROLL                                 = &H40&
%ES_NOHIDESEL                                   = &H100&
%ES_WANTRETURN                                  = &H1000&
%EM_GETSEL                                      = &HB0
%EM_SETSEL                                      = &HB1
%EM_CANUNDO                                     = &HC6
%EM_UNDO                                        = &HC7
%IMAGE_BITMAP                                   = 0

%LVM_FIRST                                      = &H1000      ' ListView messages
%LVS_REPORT                                     = &H00000001
%LVS_SINGLESEL                                  = &H00000004
%LVS_SHOWSELALWAYS                              = &H00000008
%LVM_GETITEMCOUNT                               = %LVM_FIRST + 4
%LVIF_TEXT                                      = &H0001
%LVM_INSERTITEM                                 = %LVM_FIRST + 7
%LVCF_FMT                                       = &H0001
%LVCF_WIDTH                                     = &H0002
%LVCF_TEXT                                      = &H0004
%LVCF_SUBITEM                                   = &H0008
%LVCFMT_LEFT                                    = &H00000000
%LVCFMT_RIGHT                                   = &H00000001
%LVCFMT_CENTER                                  = &H00000002
%LVM_INSERTCOLUMN                               = %LVM_FIRST + 27
%LVM_SETITEMTEXT                                = %LVM_FIRST + 46

'-----------------------------------------------------------------
' TYPE and UNION structures:  6
'-----------------------------------------------------------------
TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE POINTAPI
  x AS LONG
  y AS LONG
END TYPE

TYPE tagMSG
  hwnd AS DWORD
  message AS DWORD
  wParam AS LONG
  lParam AS LONG
  time AS DWORD
  pt AS POINTAPI
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    style AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

TYPE BITMAP
  bmType AS LONG
  bmWidth AS LONG
  bmHeight AS LONG
  bmWidthBytes AS LONG
  bmPlanes AS WORD
  bmBitsPixel AS WORD
  bmBits AS BYTE PTR
END TYPE

TYPE DRAWITEMSTRUCT
  CtlType AS DWORD
  CtlID AS DWORD
  itemID AS DWORD
  itemAction AS DWORD
  itemState AS DWORD
  hwndItem AS LONG
  hDC AS DWORD
  rcItem AS RECT
  itemData AS DWORD
END TYPE

'///////////////
TYPE LV_ITEM
    mask       AS DWORD
    iItem      AS LONG
    iSubItem   AS LONG
    STATE      AS DWORD
    stateMask  AS DWORD
    pszText    AS ASCIIZ PTR
    cchTextMax AS LONG
    iImage     AS LONG
    lParam     AS LONG
    iIndent    AS LONG
END TYPE

TYPE LVITEM
    mask       AS DWORD
    iItem      AS LONG
    iSubItem   AS LONG
    STATE      AS DWORD
    stateMask  AS DWORD
    pszText    AS ASCIIZ PTR
    cchTextMax AS LONG
    iImage     AS LONG
    lParam     AS LONG
    iIndent    AS LONG
END TYPE

TYPE LV_COLUMN
    mask AS DWORD
    fmt AS LONG
    cx AS LONG
    pszText AS ASCIIZ PTR
    cchTextMax AS LONG
    iSubItem AS LONG
    iImage AS LONG
    iOrder AS LONG
END TYPE

'-----------------------------------------------------------------
' Declared Functions:  19
'-----------------------------------------------------------------
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION BitBlt LIB "GDI32.DLL" ALIAS "BitBlt" (BYVAL hDestDC AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hSrcDC AS DWORD, BYVAL xSrc AS LONG, BYVAL ySrc AS LONG, _
                 BYVAL dwRop AS DWORD) AS LONG
DECLARE FUNCTION CallWindowProc LIB "USER32.DLL" ALIAS "CallWindowProcA" (BYVAL lpPrevWndFunc AS DWORD, BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION CreateCompatibleBitmap LIB "GDI32.DLL" ALIAS "CreateCompatibleBitmap" (BYVAL hdc AS DWORD, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG) AS DWORD
DECLARE FUNCTION CreateCompatibleDC LIB "GDI32.DLL" ALIAS "CreateCompatibleDC" (BYVAL hdc AS DWORD) AS DWORD
DECLARE FUNCTION DeleteDC LIB "GDI32.DLL" ALIAS "DeleteDC" (BYVAL hdc AS DWORD) AS LONG
DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION EnableMenuItem LIB "USER32.DLL" ALIAS "EnableMenuItem" (BYVAL hMenu AS DWORD, BYVAL uIDEnableItem AS DWORD, BYVAL uEnable AS DWORD) AS LONG
DECLARE FUNCTION GetDC LIB "USER32.DLL" ALIAS "GetDC" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetKeyState LIB "USER32.DLL" ALIAS "GetKeyState" (BYVAL nVirtKey AS LONG) AS INTEGER
DECLARE FUNCTION GetModuleHandle LIB "KERNEL32.DLL" ALIAS "GetModuleHandleA" (lpModuleName AS ASCIIZ) AS DWORD
DECLARE FUNCTION IsClipboardFormatAvailable LIB "USER32.DLL" ALIAS "IsClipboardFormatAvailable" (BYVAL dwFormat AS DWORD) AS LONG
DECLARE FUNCTION LoadImage LIB "USER32.DLL" ALIAS "LoadImageA" (BYVAL hInst AS DWORD, lpsz AS ASCIIZ, BYVAL uType AS DWORD, BYVAL cxDesired AS LONG, BYVAL cyDesired AS LONG, BYVAL fuLoad AS DWORD) AS DWORD
DECLARE FUNCTION MessageBox LIB "USER32.DLL" ALIAS "MessageBoxA" (BYVAL hWnd AS DWORD, lpText AS ASCIIZ, lpCaption AS ASCIIZ, BYVAL dwType AS DWORD) AS LONG
DECLARE FUNCTION MoveWindow LIB "USER32.DLL" ALIAS "MoveWindow" (BYVAL hWnd AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL bRepaint AS LONG) AS LONG
DECLARE FUNCTION ReleaseDC LIB "USER32.DLL" ALIAS "ReleaseDC" (BYVAL hWnd AS DWORD, BYVAL hDC AS DWORD) AS LONG
DECLARE FUNCTION SelectObject LIB "GDI32.DLL" ALIAS "SelectObject" (BYVAL hdc AS DWORD, BYVAL hObject AS DWORD) AS DWORD
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetWindowLong LIB "USER32.DLL" ALIAS "SetWindowLongA" (BYVAL hWnd AS DWORD, BYVAL nIndex AS LONG, BYVAL lNewLong AS LONG) AS LONG
DECLARE FUNCTION TrackPopupMenu LIB "USER32.DLL" ALIAS "TrackPopupMenu" (BYVAL hMenu AS DWORD, BYVAL uFlags AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nReserved AS LONG, BYVAL hWnd AS DWORD, lprc AS RECT) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD
DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" (BYVAL dwExStyle AS DWORD, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, _
    BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hWndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, lpParam AS ANY) AS DWORD

#INCLUDE "WinLIFT.INC"

'--------------------------------------------------------------------
%ID_TEXT     =  10
%IDM_FILE    = 100
%IDM_NEW     = 101
%IDM_OPEN    = 102
%IDM_SAVE    = 103
%IDM_SAVEAS  = 104
%IDM_EXIT    = 109
%IDM_EDIT    = 120
%IDM_UNDO    = 121
%IDM_CUT     = 123
%IDM_COPY    = 124
%IDM_PASTE   = 125
%IDM_SELALL  = 126

%ID_LISTVIEW = 400

'--------------------------------------------------------------------
GLOBAL hDlg  AS LONG, hEdit AS LONG, Oldproc AS LONG
GLOBAL hMnu AS LONG, hmnuFile AS LONG, hmnuEdit AS LONG, hmnuLang AS LONG
'--------------------------------------------------------------------
DECLARE CALLBACK FUNCTION DlgProc
DECLARE FUNCTION GetMenuTxt(BYVAL ItemId AS LONG) AS STRING
DECLARE FUNCTION SetMenuBitmap (BYVAL bNum AS LONG) AS LONG
DECLARE FUNCTION TextWndProc(BYVAL hWnd AS LONG, BYVAL wMsg AS LONG, _
                     BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
'DECLARE SUB DrawMenuItem(lp AS LONG)
DECLARE SUB MenuEditSet(BYVAL wParam AS LONG)
 
'
' Main entrance - create dialog, controls and menu, etc.
'
FUNCTION PBMAIN
  LOCAL rc AS RECT, nInitSkin AS LONG

  DIALOG NEW 0, "WinLIFT template", , , 320, 200, %WS_OVERLAPPEDWINDOW, TO hDlg
  DIALOG SET ICON hDlg, "PROGRAM"

  '-> Build menu
  MENU NEW BAR TO hMnu
  MENU NEW POPUP TO hmnuFile
     MENU ADD STRING, hMnuFile, GetMenuTxt(%IDM_NEW),     %IDM_NEW,    %MF_ENABLED
     MENU ADD STRING, hMnuFile, GetMenuTxt(%IDM_OPEN),    %IDM_OPEN,   %MF_ENABLED
     MENU ADD STRING, hMnuFile, "-", 0, 0
     MENU ADD STRING, hMnuFile, GetMenuTxt(%IDM_SAVE),    %IDM_SAVE,   %MF_ENABLED
     MENU ADD STRING, hMnuFile, GetMenuTxt(%IDM_SAVEAS),  %IDM_SAVEAS, %MF_ENABLED
     MENU ADD STRING, hMnuFile, "-", 0, 0
     MENU ADD STRING, hMnuFile, GetMenuTxt(%IDM_EXIT),    %IDM_EXIT,   %MF_ENABLED
     MENU ADD POPUP, hMnu, GetMenuTxt(%IDM_FILE), hmnuFile, %MF_ENABLED
  MENU NEW POPUP TO hmnuEdit
     MENU ADD STRING, hmnuEdit, GetMenuTxt(%IDM_UNDO),    %IDM_UNDO,   %MF_ENABLED
     MENU ADD STRING, hMnuEdit, "-", 0, 0
     MENU ADD STRING, hmnuEdit, GetMenuTxt(%IDM_CUT),     %IDM_CUT,    %MF_ENABLED
     MENU ADD STRING, hmnuEdit, GetMenuTxt(%IDM_COPY),    %IDM_COPY,   %MF_ENABLED
     MENU ADD STRING, hmnuEdit, GetMenuTxt(%IDM_PASTE),   %IDM_PASTE,  %MF_ENABLED
     MENU ADD STRING, hMnuEdit, "-", 0, 0
     MENU ADD STRING, hmnuEdit, GetMenuTxt(%IDM_SELALL),  %IDM_SELALL, %MF_ENABLED
     MENU ADD POPUP, hMnu, GetMenuTxt(%IDM_EDIT), hmnuEdit, %MF_ENABLED
  MENU ATTACH hMnu, hDlg

  CONTROL ADD LISTVIEW, hDlg, %ID_LISTVIEW, "", 10, 10, 301, 151 , _
                       %WS_CHILD OR %WS_VISIBLE OR %LVS_REPORT OR %LVS_SHOWSELALWAYS OR %LVS_SINGLESEL
';;    LISTVIEW SET STYLEXX hDlg, %ID_LISTVIEW, %LVS_EX_FULLROWSELECT OR %LVS_EX_GRIDLINES

  CALL GetClientRect(hDlg, rc)
  CALL CreateWindowEx(0, "BUTTON", "&Info", %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_FLAT, _
                      rc.nRight - 175, rc.nBottom - 32, 75, 25, hDlg, %IDOK, GetModuleHandle(""), BYVAL %NULL)
  CALL CreateWindowEx(0, "BUTTON", "&Close", %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_FLAT, _
                      rc.nRight - 85, rc.nBottom - 32, 75, 25, hDlg, %IDCANCEL, GetModuleHandle(""), BYVAL %NULL)

  CALL InitListView(hDlg): CALL AddToLV(hDlg)

' //////////////////////////////////////////////////////////////////////// 
' // Here we go for the magic WinLIFT section
  LOCAL zUseSkin AS ASCIIZ * 260
  zUseSkin = "Robot.sks"
  IF skInitEngine(zUseSkin, "") THEN
     CALL skSkinWindow(hDlg, "Dock|Undock|Minimize|Maximize|Restore|Close")

'   // Optional WinLIFT anchor settings
    'CALL skSetAnchorCtrl(GetDlgItem(hDlg, %ID_LISTVIEW), %ANCHOR_HEIGHT)
    'CALL skSetAnchorCtrl(GetDlgItem(hDlg, %ID_LISTVIEW), %ANCHOR_HEIGHT_WIDTH)
     CALL skSetAnchorCtrl(GetDlgItem(hDlg, %ID_LISTVIEW), %ANCHOR_WIDTH)
    'CALL skSetAnchorCtrl(GetDlgItem(hDlg, %ID_LISTVIEW), %ANCHOR_CENTER)

     CALL skSetAnchorCtrl(GetDlgItem(hDlg, %IDOK), %ANCHOR_BOTTOM_RIGHT)
     CALL skSetAnchorCtrl(GetDlgItem(hDlg, %IDCANCEL), %ANCHOR_BOTTOM_RIGHT)

  END IF

  DIALOG SHOW MODAL hDlg CALL DlgProc
END FUNCTION

'
' Dialog callback
'

CALLBACK FUNCTION DlgProc

  LOCAL hIcon AS LONG, rc AS RECT

  SELECT CASE CBMSG

     CASE %WM_SIZE
         ' Resize the two sample buttons of the dialog
'         IF CBWPARAM <> %SIZE_MINIMIZED THEN
'            GetClientRect CBHNDL, rc
'            MoveWindow GetDlgItem(CBHNDL, %IDOK), rc.nRight - 185, rc.nBottom - 35, 75, 23, %TRUE
'            MoveWindow GetDlgItem(CBHNDL, %IDCANCEL), rc.nRight - 95, rc.nBottom - 35, 75, 23, %TRUE
'         END IF

     CASE %WM_COMMAND
        SELECT CASE CBCTL
           CASE %IDOK
'CALL skDialogAlert("", "ALERT" + $CR + $CR + $CR + "Displays a modal dialog box that contains a WinLIFT icon, a set of buttons, and a brief application-specific message.", "")
'CALL skDialogError("", "ERROR" + $CR + $CR + $CR + "Displays a modal dialog box that contains a WinLIFT icon, a set of buttons, and a brief application-specific message.", "")
CALL skDialogInfo("", "INFO" + $CR + $CR + $CR + "Displays a modal dialog box that contains a WinLIFT icon, a set of buttons, and a brief application-specific message.", "")
'CALL skDialogYesNo("", "QUESTION" + $CR + $CR + $CR + "Displays a modal dialog box that contains a WinLIFT icon, a set of buttons, and a brief application-specific message.", "@Yes,No")
'CALL skDialogInput("", "INPUT" + $CR + $CR + $CR + "Displays a modal dialog box that contains a WinLIFT icon, a set of buttons, and a brief application-specific message.", "")
           CASE %IDCANCEL
                IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                   DIALOG END CBHNDL
                END IF
 
           CASE %IDM_NEW    : BEEP 'just to show it works..
           CASE %IDM_OPEN   : BEEP
           CASE %IDM_SAVE   : BEEP
           CASE %IDM_SAVEAS : BEEP
           CASE %IDM_EXIT   : DIALOG END CBHNDL                    '<- End the program
           CASE %IDM_UNDO, %IDM_CUT, %IDM_COPY, %IDM_PASTE, %IDM_SELALL 'Pass these on
        END SELECT
 
     CASE %WM_DESTROY '-> Program exit, un-subclass textbox
        IF OldProc THEN SetWindowLong CBHNDL, %GWL_WNDPROC, OldProc
 
     CASE %WM_INITMENUPOPUP
        IF CBLPARAM = 1 THEN                             'main Edit menu is activated
           TextWndProc CBHNDL, CBMSG, CBWPARAM, CBLPARAM 'process it in TextWndProc
       END IF
 
     CASE %WM_MEASUREITEM, %WM_DRAWITEM               'Pass these on and
        TextWndProc CBHNDL, CBMSG, CBWPARAM, CBLPARAM 'process them in TextWndProc
 
     CASE %WM_SIZE                                    'Resize textbox to dialog

     CASE %WM_SKGETMENUICON
        IF CBwParam THEN 
'           SELECT CASE LONG CBwParam
'           CASE %IDM_NEW   : hIcon = SetMenuBitmap(0)
'           CASE %IDM_OPEN  : hIcon = SetMenuBitmap(1)
'           CASE %IDM_SAVE  : hIcon = SetMenuBitmap(2)
'           CASE %IDM_EXIT  : hIcon = SetMenuBitmap(7)
' 
'           CASE %IDM_UNDO  : hIcon = SetMenuBitmap(6)
'           CASE %IDM_CUT   : hIcon = SetMenuBitmap(3)
'           CASE %IDM_COPY  : hIcon = SetMenuBitmap(4)
'           CASE %IDM_PASTE : hIcon = SetMenuBitmap(5)
 '          END SELECT
         ' Note the skEngine delete the returned hIcon handle once it has done with it
           FUNCTION = hIcon
        END IF
        EXIT FUNCTION

  END SELECT
 
END FUNCTION
 
'
' Return menu item string
'
FUNCTION GetMenuTxt(BYVAL ItemId AS LONG) AS STRING
  SELECT CASE ItemId
     CASE %IDM_FILE    : FUNCTION = "&File"
     CASE %IDM_NEW     : FUNCTION = "&New"     & CHR$(9) & "Ctrl + N"
     CASE %IDM_OPEN    : FUNCTION = "&Open..." & CHR$(9) & "Ctrl + O"
     CASE %IDM_SAVE    : FUNCTION = "&Save"    & CHR$(9) & "Ctrl + S"
     CASE %IDM_SAVEAS  : FUNCTION = "&Save as..."
     CASE %IDM_EXIT    : FUNCTION = "E&xit"    & CHR$(9) & "Alt + F4"
 
     CASE %IDM_EDIT    : FUNCTION = "&Edit"
     CASE %IDM_UNDO    : FUNCTION = "&Undo"    & CHR$(9) & "Ctrl + Z"
     CASE %IDM_CUT     : FUNCTION = "Cu&t"     & CHR$(9) & "Ctrl + X"
     CASE %IDM_COPY    : FUNCTION = "&Copy"    & CHR$(9) & "Ctrl + C"
     CASE %IDM_PASTE   : FUNCTION = "&Paste"   & CHR$(9) & "Ctrl + V"
     CASE %IDM_SELALL  : FUNCTION = "Select &All" & CHR$(9) & "Ctrl + A"
  END SELECT
END FUNCTION
 
'
' Enable or disable edit menu items
'
SUB MenuEditSet(BYVAL wParam AS LONG)
  LOCAL lRes AS LONG, selStart AS LONG, selEnd AS LONG
 
  IF SendMessage(hEdit, %EM_CANUNDO, 0, 0) THEN          '<- UNDO
     CALL EnableMenuItem (wParam, %IDM_UNDO, %MF_ENABLED)
  ELSE
     CALL EnableMenuItem (wParam, %IDM_UNDO, %MF_GRAYED)
  END IF
 
  lRes = SendMessage(hEdit, %EM_GETSEL, VARPTR(selStart), VARPTR(selEnd))
  IF selStart = selEnd THEN                               '<- CUT & COPY
     CALL EnableMenuItem (wParam, %IDM_CUT, %MF_GRAYED)
     CALL EnableMenuItem (wParam, %IDM_COPY, %MF_GRAYED)
  ELSE
     CALL EnableMenuItem (wParam, %IDM_CUT, %MF_ENABLED)
     CALL EnableMenuItem (wParam, %IDM_COPY, %MF_ENABLED)
  END IF
 
  IF IsClipboardFormatAvailable(%CF_TEXT) THEN            '<- PASTE
     CALL EnableMenuItem (wParam, %IDM_PASTE, %MF_ENABLED)
  ELSE
     CALL EnableMenuItem (wParam, %IDM_PASTE, %MF_GRAYED)
  END IF
 
  IF SendMessage(hEdit, %WM_GETTEXTLENGTH, 0, 0) THEN      '<- SELECT ALL
     CALL EnableMenuItem (wParam, %IDM_SELALL, %MF_ENABLED)
  ELSE
     CALL EnableMenuItem (wParam, %IDM_SELALL, %MF_GRAYED)
  END IF
 
END SUB
 
'
' SetMenuBitmap - loads a bitmap part into a menu tem
'
FUNCTION SetMenuBitmap (BYVAL bNum AS LONG) AS LONG
  LOCAL hBmp1 AS LONG, hBmp2 AS LONG, hDC AS LONG, memDC1  AS LONG, memDC2 AS LONG
 
' Load the bitmap to use
' ~~~~~~~~~~~~~~~~~~~~~~
  hBmp1 = LoadImage(GetModuleHandle(BYVAL 0&), BYVAL 1, %IMAGE_BITMAP, 0, 0, %LR_LOADMAP3DCOLORS)
 
' Grab Screen's DC and create two compatible memory DC's
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  hdc    = GetDc(0)
  memDC1 = CreateCompatibleDC (hdc)
  memDC2 = CreateCompatibleDC (hdc)
 
' Create 16x16 pixel bitmap
' ~~~~~~~~~~~~~~~~~~~~~~~~~
  hBmp2 = CreateCompatibleBitmap(hdc, 16, 16)
 
' Release the dc - don't need it anymore.
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ReleaseDC 0, hdc
 
' Select the bitmaps into the memory DC's
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  SelectObject memDC1, hBmp1
  SelectObject memDC2, hBmp2
 
' Copy selected part of bitmap1 to bitmap2
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  BitBlt memDC2, 0, 0, 16, 16, memDC1, bNum * 16, 0, %SRCCOPY
 
' Cleanup
' ~~~~~~~
  DeleteDC memDC1
  DeleteDC memDC2
  DeleteObject hBmp1    '(hBmp2 is deleted in DrawMenuItem)
 
  FUNCTION = hBmp2      'return handle to stretched bitmap
END FUNCTION
 
'
' Subclassed text control procedure
'
FUNCTION TextWndProc(BYVAL hWnd AS LONG, BYVAL wMsg AS LONG, _
                     BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
  SELECT CASE wMsg
     CASE %WM_INITMENUPOPUP
        MenuEditSet wParam
        EXIT FUNCTION
 
     CASE %WM_CONTEXTMENU
        CALL TrackPopupMenu (hmnuEdit, 0, LOWRD(lParam), HIWRD(lParam), 0, hWnd, BYVAL %NULL)
        EXIT FUNCTION
 
     CASE %WM_COMMAND
        SELECT CASE LOWRD(wParam)
           CASE %IDM_UNDO   : CALL SendMessage(hWnd, %EM_UNDO,  0, 0)
           CASE %IDM_CUT    : CALL SendMessage(hWnd, %WM_CUT,   0, 0)
           CASE %IDM_COPY   : CALL SendMessage(hWnd, %WM_COPY,  0, 0)
           CASE %IDM_PASTE  : CALL SendMessage(hWnd, %WM_PASTE, 0, 0)
           CASE %IDM_SELALL : CALL SendMessage(hWnd, %EM_SETSEL, 0, -1)
        END SELECT
 
    CASE %WM_KEYDOWN
        IF (GetKeyState(%VK_CONTROL) AND &H8000) <> 0 THEN 'Control pressed
           SELECT CASE CHR$(wparam)
              CASE "N" : MessageBox hWnd, "%IDM_NEW selected",  "Message", %MB_OK 'Ctrl + N
              CASE "O" : MessageBox hWnd, "%IDM_OPEN selected", "Message", %MB_OK 'Ctrl + O
              CASE "S" : MessageBox hWnd, "%IDM_SAVE selected", "Message", %MB_OK 'Ctrl + S
              CASE "A" : CALL SendMessage(hWnd, %EM_SETSEL, 0, -1)                'Ctrl + A
           END SELECT
        END IF
         
  END SELECT
 
  FUNCTION = CallWindowProc(OldProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

'///////////////
FUNCTION ListView_GetItemCount (BYVAL hWnd AS DWORD) AS LONG
    FUNCTION = SendMessage(hWnd, %LVM_GETITEMCOUNT, 0, 0)
END FUNCTION

FUNCTION ListView_InsertItem (BYVAL hWnd AS LONG, pitem AS LV_ITEM) AS LONG
    FUNCTION = SendMessage(hWnd, %LVM_INSERTITEM, 0, VARPTR(pitem))
END FUNCTION

FUNCTION ListView_InsertColumn (BYVAL hWnd AS DWORD, BYVAL iCol AS LONG, _
   pcol AS LV_COLUMN) AS LONG
    FUNCTION = SendMessage(hWnd, %LVM_INSERTCOLUMN, iCol, VARPTR(pcol))
END FUNCTION

SUB ListView_SetItemText (BYVAL hWndLV AS DWORD, BYVAL i AS LONG, _
   BYVAL iSubItem AS LONG, pszText AS ASCIIZ)
    LOCAL ms_lvi AS LV_ITEM
    ms_lvi.iSubItem = iSubItem
    ms_lvi.pszText = VARPTR(pszText)
    SendMessage hWndLV, %LVM_SETITEMTEXT, i, VARPTR(ms_lvi)
END SUB

'******************************************************************************
Sub InitListView(ByVal hDlg As Dword)
'******************************************************************************
  Local lStyle, hLV  As Long
  Local tLVC    As LV_COLUMN
  Local szBuf   As Asciiz * 32
  Local lCol    As Long

  Control Handle hDlg, %ID_LISTVIEW To hLV

  tLVC.mask    = %LVCF_FMT OR %LVCF_TEXT OR %LVCF_SUBITEM OR %LVCF_WIDTH
  tLVC.pszText = VarPtr(szBuf)

  szBuf = "File Name"
  tLVC.iOrder = 0
  tLVC.cx = 135
  tLVC.fmt = %LVCFMT_LEFT
  ListView_InsertColumn hLV, 0, tLVC

  szBuf = "Modified"
  tLVC.iOrder = 1
  tLVC.cx = 120
  tLVC.fmt = %LVCFMT_CENTER
  ListView_InsertColumn hLV, 1, tLVC

  szBuf = "Size"
  tLVC.iOrder = 2
  tLVC.cx = 60
  tLVC.fmt = %LVCFMT_RIGHT
  ListView_InsertColumn hLV, 2, tLVC

  szBuf = "Ratio"
  tLVC.iOrder = 3
  tLVC.cx = 40
  tLVC.fmt = %LVCFMT_RIGHT
  ListView_InsertColumn hLV, 3, tLVC

  szBuf = "Packed"
  tLVC.iOrder = 4
  tLVC.cx = 60
  tLVC.fmt = %LVCFMT_RIGHT
  ListView_InsertColumn hLV, 4, tLVC

  szBuf = "Path"
  tLVC.iOrder = 5
  tLVC.cx = 150
  tLVC.fmt = %LVCFMT_LEFT
  ListView_InsertColumn hLV, 5, tLVC

  LISTVIEW SET STYLEXX hDlg, %ID_LISTVIEW, %LVS_EX_CHECKBOXES

End Sub

'******************************************************************************
Sub AddToLV(ByVal hDlg As Dword)
'******************************************************************************
  Local pItem As LVITEM
  Local i, j, hLV As Long
  Local Txt As Asciiz*128

  Control Handle hDlg, %ID_LISTVIEW To hLV

  For j= 0 To 100
    i=ListView_GetItemCount(hlv)
    pItem.Mask=%LVIF_TEXT
    pItem.iItem = i
    pItem.iSubItem = 0
    Txt = "Row" + Str$(j) + " - Col 0"
    pItem.pszText=VarPtr(Txt)
    i=ListView_InsertItem (hlv,pItem)

    Txt = "Row" + Str$(j) + " - Col 1"
    ListView_SetItemText hlv,i,1,Txt
    Txt = "Row" + Str$(j) + " - Col 2"
    ListView_SetItemText hlv,i,2,Txt
    Txt = "Row" + Str$(j) + " - Col 3"
    ListView_SetItemText hlv,i,3,Txt
    Txt = "Row" + Str$(j) + " - Col 4"
    ListView_SetItemText hlv,i,4,Txt
    Txt = "Row" + Str$(j) + " - Col 5"
    ListView_SetItemText hlv,i,5,Txt
  Next j

End Sub
